var vspacing=10,hspacing=10;
var colWidth;
var yBase,x=[],y=[];
var dtX, dtY, dtW, dtH;
var lastLayout=false;
var feedFormDisplayed=false;
var screenMaskShown=false;
var windowWidth=0;
var windowHeight=0;
var updateTimer=false;
var cancelTitleUpdate=false;
var blockClicks=0;

// init page
function init(){
    hideLIP();
    dd.elements.separator.hide();
    yBase=dd.elements.separator.y;
    winOnResize(false);
    setInterval("checkResize()",10);
    for(var i=0;i<dd.elements.length;i++) {
    	if(dd.elements[i].name.substr(0,8)=='feedItem') {
    		dgi(dd.elements[i].name).style.visibility="visible";
    	}
    }
    checkUpdates(false);
    setImages();
}

// feeds updates
function checkUpdates(forceUpdateAll){
	var updateNeeded=false;
	for(var i=0;i<dd.elements.length;i++) if(dd.elements[i].name.substr(0,8)=='feedItem'){
		if(dgi(dd.elements[i].name.substr(8)+'_nu').innerHTML<=0 || forceUpdateAll){
			updateNeeded=true;
			setIcon(dd.elements[i].name,'l');
		}
		else dgi(dd.elements[i].name.substr(8)+'_nu').innerHTML-=wl.rVar.updatesCheckFrequency;
	}
	if(updateNeeded) fAS ("all","checkUpdates",((forceUpdateAll)?true:false)); else W.setTimeout('checkUpdates()',wl.rVar.updatesCheckFrequency*1000);
}

/**
 * Set display type
 * @param d:'all', 'day', 'last', 'number'
 */
function setFeedsDisplay(d){
	fAS(d,'setFeedsDisplay');
	feedsDisplay=d;
}

/**
 * Update cookie used to detect last time a tab has been displayed. Called on tab display
 * @param tabId: id of tab
 * @param ts: php timestamp
 */
function rssUpdateCookie(tabId,ts){
	var e,tabs={},strTab='',c=wl.cookie.get('weezoRSS'+rID);

	if(c) {
		c=c.replace(/%3D/g,'=').replace(/%2C/g,',');
		c=c.split(',')
		for(i=0;i<c.length;i++){
			tmp=c[i].split('=');
			tabs[tmp[0]]=tmp[1];
		}
	}
	tabs[tabId]=ts;
	for(e in tabs) strTab+=((strTab)?',':'')+e+"="+tabs[e];

	wl.cookie.set('weezoRSS'+rID,strTab,60*24*7);
}

// Set icons and images src from alt tags
function setImages(){
	var imgs=dgn('img','all');
	if(imgs) for(var i=0;i<imgs.length;i++){if(src=(obj=imgs[i]).alt) {obj.src=src;obj.alt='';}}
}
// Set feed icon
function setIcon(iconId,imageSrc){
	if(imageSrc=='l') {
		wl.loading.set(iconId+"_icon");
		return;
	}
	if(imageSrc=='e') imageSrc=wl.ico.alert;
	wl.loading.stop(iconId+"_icon")
	dgi(iconId+"_icon").src=imageSrc
}
// window resize
function checkResize(){
	if(windowWidth!=0){
		if((dd.getWndW()!=windowWidth || dd.getWndH()!=windowHeight)) winOnResize(false);
	}
	windowWidth=dd.getWndW();
	windowHeight=dd.getWndH();
}
// Load in progress
function hideLIP(){dgi("lip").style.display="none";}
function showLIP(){dgi("lip").style.display="inline";}

// Tooltip
function tooltipGetContent(nodeId){
	if(W.dragInProgress && dragInProgress) return false;
	fAS(nodeId.substr(2),'getFeedInfo',1);
	D.comForm.target='';
	return '<img id="tooltipLoading" src="">';
}


/**
 * Drag functions
 */
function preDrag(){
	if(dd.obj.name.substr(0,8)!='feedItem') return true;
	dtX=dd.obj.x; dtY=dd.obj.y; dtW=dd.obj.w; dtH=dd.obj.h;
    dd.elements.separator.show();
    dd.obj.setOpacity(0.85);
    duringDrag();
    blockClicks=1;
    return true;
}
function preDrop(){
	if(dd.obj.name.substr(0,8)!='feedItem') return;
	if(isDragging()) setTimeout('blockClicks=0',50); else blockClicks=0;
    resetPos(true,false);
}
function isDragging(){
    //if(dd.obj) alert(dd.obj.pickTime()+'/'+Math.abs(dd.obj.x-dd.obj.pickX)+'x'+Math.abs(dd.obj.y-dd.obj.pickY)); else alert('no obj')
    if(dd.obj && (dd.obj.pickTime()>500 || Math.abs(dd.obj.x-dd.obj.pickX)>9 || Math.abs(dd.obj.y-dd.obj.pickY)>9)) return true;
    return false;
}
function duringDrag(){
    var colNb=0,itemNb=-1,max=0,maxNb=-1,nbCols=wl.rVar.nbColumns;
	if(dd.obj.name.substr(0,8)!='feedItem') return;

    var xPos=dd.obj.x+dd.obj.w/2, yPos=dd.obj.y+dd.obj.h/2;

    var colWidth=Math.floor((dd.getWndW()- hspacing)/nbCols);

    // Detect column
    for(var o=0;o<nbCols;o++){
        if((xPos>=colWidth*o+hspacing/2 || o==0) && (xPos<=colWidth*(o+1)+hspacing/2 || o==(nbCols-1))) {colNb=o;break;}
    }

    var aboveItem=-1;
    var belowItem=-1;
    // Detect position
    for(var o=0;o<col[colNb].length;o++){
        if(yPos<y[col[colNb][o]] && (aboveItem==-1 || y[col[colNb][o]]<y[aboveItem])) aboveItem=col[colNb][o];
        if(yPos>=y[col[colNb][o]] && (belowItem==-1 || y[col[colNb][o]]>=y[belowItem])) belowItem=col[colNb][o];
    }

    if(aboveItem==dd.obj.name || belowItem==dd.obj.name){
    	dd.elements.separator.moveTo(dtX,dtY);
    	dd.elements.separator.resizeTo(dtW,dtH);
    	return;
    }

    if(aboveItem!=-1) {
    	dd.elements.separator.resizeTo(dtW,4);
    	sepY=dd.elements[aboveItem].y-vspacing/2-2;
    }
    else {
    	dd.elements.separator.resizeTo(dtW,dtH);
    	if(belowItem!=-1) sepY=dd.elements[belowItem].y+dd.elements[belowItem].h+vspacing/2; else sepY=yBase;
    }

    dd.elements.separator.moveTo(colWidth*colNb+hspacing/2, sepY);
}

// Single feed fold / unfold
function feedCollapse(itemId, state){
	if(itemId.item) return;
	itemId=itemId.substr(0,itemId.length-5);
	dd.elements['feedItem'+itemId].resizeTo(false,'auto');
	dd.recalc();
	resetPos(false,true);
	if(state=='doneFold' || state=='doneUnfold') fAS(itemId,'changeFolding',((state=='doneFold')?'1':'0'));
}
// All feeds fold
function collapseAll(){
	var id,s,i,e;
	for(i=0;i<dd.elements.length;i++) {
		e=dd.elements[i];
		if(e.name.substr(0,8)=='feedItem'){
			id=e.name.substr(8)+'_cDiv';
			s=dgi(id).style;
			s.overflow='hidden';
			if(dgi(id+'BtMinus') && dgi(id+'BtPlus')) {dgi(id+'BtPlus').style.display='inline';	dgi(id+'BtMinus').style.display='none';}
			s.height=((phpBrowser=='ie')?1:0)+'px';
			s.visibility="hidden";
			e.resizeTo(false,'auto');
		}
	}
	dd.recalc();
	resetPos(false,true);
	fAS('all','changeFolding','1');
}
// All feeds unfold
function unfoldAll(){
	var id;
	for(var i=0;i<dd.elements.length;i++) if(dd.elements[i].name.substr(0,8)=='feedItem'){
		id=dd.elements[i].name.substr(8)+'_cDiv';
		dgi(id).style.overflow='';
		if(dgi(id+'BtMinus') && dgi(id+'BtPlus')) {dgi(id+'BtPlus').style.display='none';	dgi(id+'BtMinus').style.display='inline';}
		dgi(id).style.height='';
		dgi(id).style.visibility="visible";
		dd.elements[i].resizeTo(false,'auto');
	}
	dd.recalc();
	resetPos(false,true);
	fAS('all','changeFolding','0');
}

// All feeds unfold
function setAllItemsDisplay(compact){
	fAS('all','setCompact',compact);
}


/**
 * Feeds positioning
 */
function winOnResize(widthOnly){
    colWidth=Math.floor((dd.getWndW()- hspacing)/wl.rVar.nbColumns);

    for(var i=0;i<dd.elements.length;i++) if(dd.elements[i].name.substr(0,8)=='feedItem'){
        dd.elements[i].resizeTo(colWidth-hspacing,'auto');
    }
    dd.recalc();
    if(!widthOnly) resetPos(false,true);
}
// Recompute items positions
function resetPos(updateServer, lockItemsLayout){
    var min,maxY=0;
    dd.elements.separator.hide()
    if(dd.obj) dd.obj.setOpacity(1);
    colWidth=Math.floor((dd.getWndW()-hspacing)/wl.rVar.nbColumns);

    x=[]; y=[];
    if(!lockItemsLayout) {
    	col=[];
	    for(var o=0;o<wl.rVar.nbColumns;o++) col[o]=[];
    }

    // Get Y position, and associate feeds to cols (if !lIL)
    for(var i=0;i<dd.elements.length;i++) if(dd.elements[i].name.substr(0,8)=='feedItem'){
    	eltId=dd.elements[i].name;

    	//dgi(dd.elements[i].name+'_title').innerHTML=dd.elements[i].name+ " - "+i;
        x[eltId]=dd.elements[i].x+dd.elements[i].w/2;
        y[eltId]=dd.elements[i].y+dd.elements[i].h/2;
        if(!lockItemsLayout){
	        for(var o=0;o<wl.rVar.nbColumns;o++){
	            if((x[eltId]>=colWidth*o+hspacing/2||o==0) && (x[eltId]<=colWidth*(o+1)+hspacing/2 || (o==wl.rVar.nbColumns-1))){
	                col[o][col[o].length]=dd.elements[i].name;
	            }
	        }
        }
    }

    var layout="";
    var sortedCol=[];
    for(o=0;o<wl.rVar.nbColumns;o++){
        itemId=-1;
        yPos=yBase+vspacing/2;
        if(o) layout+="/";
		sortedCol[o]=[];

		if(!lockItemsLayout) {
	        for(var u=0;u<col[o].length;u++) {
	            min=5000;
	            if(u) layout+=";";
	            for(var i=0;i<col[o].length;i++) {
	                if(y[col[o][i]]<min) {min=y[col[o][i]];itemId=col[o][i];}
	            }
	            dd.elements[itemId].moveTo(hspacing/2+colWidth*o,yPos);
	            maxY=Math.max(dd.elements[itemId].y+dd.elements[itemId].h,maxY);

		        x[itemId]=3*hspacing/2+colWidth*o;
		        y[itemId]=5000;

	            yPos+=dd.elements[itemId].h+vspacing;

	            layout+=dd.elements[itemId].name.substr(8);
	            sortedCol[o][u]=itemId;
	        }
		}
		else{
			for(var u=0;u<col[o].length;u++) {
				x[col[o][u]]=3*hspacing/2+colWidth*o;
				if(!dd.elements[col[o][u]]) break; // debug
				dd.elements[col[o][u]].moveTo(hspacing/2+colWidth*o,yPos);
				yPos+=vspacing+dd.elements[col[o][u]].h;

				maxY=Math.max(yPos+vspacing/2,maxY);

				layout+=dd.elements[col[o][u]].name.substr(8);
				if(u) layout+=";";
			}
		}
    }

    // replace col array by sorted array
    if(!lockItemsLayout) col=sortedCol;

    for(var i=0;i<dd.elements.length;i++) {
    	if(dd.elements[i].name.substr(0,8)=='feedItem') {
    		y[dd.elements[i].name]=dd.elements[dd.elements[i].name].y+dd.elements[dd.elements[i].name].h/2;
    	}
    }
    dgi("mainTable").style.height=Math.max(maxY,dd.getWndH())-dgi("mainTableHeader").offsetHeight;
    if(updateServer && layout!=lastLayout) fAS(layout, 'updateLayout');
    lastLayout=layout;
    dd.elements["screenMask"].resizeTo(dd.getWndW(),dgi("mainTable").offsetHeight-1);
    //dd.elements["screenMask"].resizeTo('100%','100%');
  	if(!screenMaskShown) dd.elements["screenMask"].moveTo(-5000,-5000);
}


/**
 * Create new feed
 */
function showNewFeedForm(url){
	if(!url) {
		setScreenMask();
		dgi("newFeedLinks").innerHTML=dgi("newFeedURLError").innerHTML='&nbsp;';
		dgi("newFeedURL").value='';
		dgi("newFeedFormBt").style.cursor='';
		centerNewFeedForm();
		dgi("newFeedURL").focus();
		feedFormDisplayed=true;
	}
}
// Show and center new feed form
function centerNewFeedForm(){
	var f=dd.elements["newFeedForm"];
	f.show();
	f.div.style.display="block";
	f.moveTo(dd.getWndW()/2-f.w/2,dd.getWndH()/2+dd.getScrollY()-dgi('newFeedFormDiv').offsetHeight/2);
	f.maximizeZ();
}
function hideNewFeedForm(){
	dd.elements["newFeedForm"].hide();
	removeScreenMask();
	feedFormDisplayed=false;
}
function setNewFeedError(err){
	dgi("newFeedURLError").innerHTML=err;
	dgi("newFeedFormBt").style.cursor='';
	centerNewFeedForm();
}
function addFeed(url){
	// URL provided by setNewFeedLinks
	if(url){fAS(url,'addFeed');	return;}

	// URL retreived from user input
	var v=dgi('newFeedURL').value,re=/(http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/i
	if(dgi("newFeedFormBt").style.cursor=="wait") return;
	dgi("newFeedFormBt").style.cursor="wait";
	dgi("newFeedURLError").innerHTML='&nbsp;';
	if(v.substr(0,7)!='http://' && v.substr(0,8)!='https://') {v='http://'+v;dgi('newFeedURL').value=v}
	if(!re.test(v)) setNewFeedError(wl.capt.bookmarksInvalidURL);
	else fAS(v,'addFeed');
}

/**
 * Display a list of all feeds available for a given web site
 */
function setNewFeedLinks(links){
	var e,l,cont=dgi('newFeedLinks'),o='';
	for(e in links) o+=newFeedBtTemplate.replace(/CONTENT/,links[e]['title']).replace(/ACTION/,"addFeed('"+links[e]['href']+"')")+'<br>';
	cont.innerHTML=o;
	dgi("newFeedFormBt").style.cursor='';
	dgi("newFeedURLError").innerHTML='';
	centerNewFeedForm();
}
function checkFeedURL(){}
function checkKey(e){
	var kc;
	if(e) kc=e.which; else {if(W.event) kc=W.event.keyCode; else return;}
	if(kc==27 && feedFormDisplayed) hideNewFeedForm();
	if(kc==13 && feedFormDisplayed) addFeed();
}

// Insert newly created feed
function insertNewFeed(feedId,colNb){
	var colWidth=Math.floor((dd.getWndW()-hspacing)/wl.rVar.nbColumns);
	hideNewFeedForm();
	removeScreenMask();
	// Create and show feed
	ADD_DHTML('feedItem'+feedId+PICKDELAY+500);
	dd.elements["feedItem"+feedId].moveTo(dd.elements["newFeedForm"].x+dd.elements["newFeedForm"].w/2-dd.elements["feedItem"+feedId].w/2,dd.elements["newFeedForm"].y+dd.elements["newFeedForm"].h/2-dd.elements["feedItem"+feedId].h/2);
	dd.elements["feedItem"+feedId].resizeTo(colWidth-hspacing,'auto');
	dd.elements["feedItem"+feedId].show();

	// Compute feed position
	yPos=yBase; belowItem=-1;
	for(var i=0;i<col[colNb].length;i++) if(dd.elements[col[colNb][i]].y>yPos) {yPos=dd.elements[col[colNb][i]].y; belowItem=col[colNb][i];}
	if(belowItem!=-1) yPos+=dd.elements[belowItem].h+vspacing; else yPos+=vspacing;
	col[colNb][col[colNb].length]='feedItem'+feedId;
	W.setTimeout("animNewFeed('"+feedId+"', "+(colWidth*colNb+hspacing/2)+", "+yPos+",20)",20)
	setImages();
}
function animNewFeed(feedId,destX,destY,step){
	step--;
	if(step>0) {
		dd.elements["feedItem"+feedId].moveTo((3*dd.elements["feedItem"+feedId].x+1*destX)/4, (3*dd.elements["feedItem"+feedId].y+1*destY)/4);
		W.setTimeout("animNewFeed('"+feedId+"', "+destX+", "+destY+", "+step+")",20)
	}
	// Done repos
	else {
		dd.elements["feedItem"+feedId].moveTo(destX,destY);
		clearAllFeeds(false);
		rebuildDragElts(true);
	}
}
/**
 * Clear/rebuild feeds drag elts
 */
function clearAllFeeds(removeHTML){
	for(var i=dd.elements.length-1;i>=0;i--) {if(dd.elements[i].name.substr(0,8)=='feedItem') dd.elements[i].del(true);}
	if(removeHTML) dgi('feedsDiv').innerHTML='';
	dd.recalc();
}
function rebuildDragElts(lockColumns){
	var ef=dgi('feedsDiv').childNodes;
	for(var i=0;i<ef.length;i++){
		if(ef[i].id!=undefined)	ADD_DHTML(ef[i].id+PICKDELAY+500,1);
	}
	if(dd.ie) dd.recalc(); else dd.mkWzDom();
	winOnResize(true);
	resetPos(false,lockColumns);
	for(var i=0;i<ef.length;i++){
		if(ef[i].id!=undefined) dgi(ef[i].id).style.visibility="visible";
	}
}

// Open feed link
function ol(url, title){
	if(blockClicks || isDragging()) return;
	if(wl.rVar.noPopup || !parent || parent===W) return W.open(url);
	var pp=parent.winPadding;w=parent.dd.getWndW()-pp.left-pp.right,h=parent.dd.getWndH()-pp.top-pp.bottom,width=Math.floor(5*w/6),height=Math.floor(5*h/6);
	var windowName="viewWindow"+Math.random()
	parent.winOpenLocation(url,windowName,"Weezo",winMyId);
	with(parent.win(windowName)){
		setCaption(title);
		moveTo(pp.left+Math.floor((w-width)/2),pp.top+Math.floor((h-height)/2));
		resizeInnerTo(width,height);
		show(); bringToFront();
	}
}

// Feed title edition
function editTitle(itemId){
	if(blockClicks || isDragging()) return;
	var title=dgi(itemId+'_title').innerHTML;
	var w=dgi(itemId+'_title').parentNode.offsetWidth-dgi(itemId+'_icon').offsetWidth-18;
	if(title.substr(0,6).toLowerCase()=='<input') return;
	dgi(itemId+'_title').innerHTML='<input id="'+itemId+'_input" onkeypress="'+((phpBrowser=='gecko')?'editTitleKP(\''+itemId+'\',event.which)':'editTitleKP(\''+itemId+'\',-1)')+'" type="text" value="'+title.replace(/"/gi,'')+'" onblur="commitTitleChange(\''+title.replace(/'/gi,"\\'").replace(/"/gi,"")+'\',\''+itemId+'\')" class="input" style="vertical-align:middle; width:'+w+'px">'; // foo.replace(/'/g,"\\'"));
	dgi(itemId+'_input').focus();
}
function editTitleKP(pid,kc){
	if(kc==-1) {if(W.event) kc=W.event.keyCode; else return;}
	if(kc==13) dgi(pid+"_input").onblur();
	if(kc==27) {cancelTitleUpdate=true;dgi(pid+"_input").onblur();}
}
function commitTitleChange(prevTitle,itemId){
	if(cancelTitleUpdate){dgi(itemId+'_title').innerHTML=prevTitle;}
	else{
		var newTitle=dgi(itemId+'_input').value;
		dgi(itemId+'_title').innerHTML=newTitle;
		if(newTitle!=prevTitle) fAS(itemId.substr(8),'changeTitle',newTitle);
	}
	cancelTitleUpdate=false;
}

/**
 * Feeds Options
 */
var optionFeedId=false;

function dispOpt(id){
	if(optionFeedId!='feedItem'+id){
		optionFeedId='feedItem'+id;
		if(dgi(id+'_mi').innerHTML==0) {
			dgi("optionMaxItems").value=wl.rVar.maxItems;
			dgi("optionMaxItems").disabled=true;
			dgi("optionMaxItemsDefault").checked=true;
		}
		else {
			dgi("optionMaxItems").value=dgi(id+'_mi').innerHTML;
			dgi("optionMaxItems").disabled=false;
			dgi("optionMaxItemsDefault").checked=false;
		}
		dgi('optionURL').value=dgi(id+'_url').innerHTML;
	}

	setScreenMask('hideOptionsForm()');
	dd.elements.feedOptionsForm.resizeTo('auto','auto');
	if(dd.elements[optionFeedId].x+dd.elements[optionFeedId].w-dd.elements.feedOptionsForm.w>hspacing)
		dd.elements.feedOptionsForm.moveTo(dd.elements[optionFeedId].x+dd.elements[optionFeedId].w-dd.elements.feedOptionsForm.w, dd.elements[optionFeedId].y);
	else
		dd.elements.feedOptionsForm.moveTo(hspacing, dd.elements[optionFeedId].y);
	dd.elements.feedOptionsForm.maximizeZ();


	dd.elements.feedOptionsForm.show();
}
function hideOptionsForm(){dd.elements.feedOptionsForm.hide();removeScreenMask();}
// Change feed max displayed lines
function optionMaxItems(){
	id=optionFeedId.substr(8);
	if((!isNaN(dgi("optionMaxItems").value) && !dgi("optionMaxItemsDefault").checked && dgi("optionMaxItems").value!=dgi(id+'_mi').innerHTML) || (dgi(id+'_mi').innerHTML>0 && dgi("optionMaxItemsDefault").checked))
		fAS(optionFeedId.substr(8), 'changeMaxItems',((dgi("optionMaxItemsDefault").checked)?'0':dgi("optionMaxItems").value));
}
function optionMaxItemsDefault(){
	if(dgi("optionMaxItemsDefault").checked) dgi("optionMaxItems").disabled=true; else dgi("optionMaxItems").disabled=false;
	optionMaxItems();
}
// Refresh feed
function optionRefreshFeed(){
	setIcon(optionFeedId,"l");
	fAS(optionFeedId.substr(8), 'checkUpdates');
	hideOptionsForm();
}
// Toggle compact display
function optionCompactDisplay(){fAS(optionFeedId.substr(8), 'setCompact',((dgn("optionCompactDisplay").checked)?'true':'false'))}
function optionChangeURL(){if(editAllowed) return; dgi('optionIcon').src=wl.ico.loading;fAS(optionFeedId.substr(8), 'changeURL',dgi('optionURL').value)}

/**
 * Delete Feed
 */
function optionDeleteFeed(feedId){
	hideOptionsForm();
	setScreenMask();
	dgi('suppressFeedName').innerHTML='"'+dgi(feedId+'_title').innerHTML+'"';
	dgi('suppressFeedId').innerHTML=feedId;
	dd.elements["deleteFeedForm"].show(); dgi("newFeedForm").style.display="block";
	dd.elements["deleteFeedForm"].moveTo(dd.getWndW()/2-dd.elements["newFeedForm"].w/2,dd.getWndH()/3+dd.getScrollY()-dd.elements["newFeedForm"].h/2);
	dd.elements["deleteFeedForm"].maximizeZ();
	dd.recalc();
}
function hideDeleteFeedForm(){
	dd.elements.deleteFeedForm.hide();
	hideOptionsForm();
}
function deleteFeed(){fAS(dgi('suppressFeedId').innerHTML.substr(8),'deleteFeed');}
function removeDeletedFeed(itemId){
	hideDeleteFeedForm(); dd.elements[itemId].del(); dgi(itemId).outerHTML='';	resetPos(false,false);
}

// Screen mask
var screenMaskOverFunction=false;
function setScreenMask(mouseOutDetect){
	screenMaskShown=true;
	if(mouseOutDetect) {
		dd.elements["screenMask"].setOpacity(0.01);
		screenMaskOverFunction="removeScreenMask();"+mouseOutDetect;
	}
	else {
		dd.elements["screenMask"].setOpacity(0.2);
		screenMaskOverFunction="";
	}
	dd.elements["screenMask"].maximizeZ(); dd.elements["screenMask"].show(); dd.elements["screenMask"].moveTo(0,0);
}
function removeScreenMask(){screenMaskShown=false; dd.elements["screenMask"].hide(); dd.elements["screenMask"].moveTo(-5000,0);}
function screenMaskOver(){if(screenMaskOverFunction) eval(screenMaskOverFunction);}

function addImportedFeeds(applicationName){fAS(applicationName,'addImportedFeeds')}

/**
 * file path form
 */
function showFilePathForm(){
	setScreenMask();
	dd.elements["filePathForm"].show(); dgi("filePathForm").style.display="block";
	dd.elements["filePathForm"].moveTo(dd.getWndW()/2-dd.elements["filePathForm"].w/2,dd.getWndH()/2+dd.getScrollY()-dd.elements["filePathForm"].h/2);
	dd.elements["filePathForm"].maximizeZ();
	dgi("filePath").focus();
	feedFormDisplayed=true;
}
function hideFilePathForm(){
	dd.elements["filePathForm"].hide();
	removeScreenMask();
}


// Link images repositioning
function posImg(imgId){
	if(!dgi(imgId)) return;
	var imw=dgi(imgId).offsetWidth,imh=dgi(imgId).offsetHeight;
	if(imw<3 ||imh<3){
		var pn=dgi(imgId).parentNode;
		var tdn=pn.parentNode
		tdn.removeChild(pn);
		tdn.innerHTML='<ul><li>'+tdn.innerHTML+'</li></ul>';
		return
	}
	if(imh==0 ||imw==0) return;
	var maskw=wl.rVar.linkImageWidth,maskh=wl.rVar.linkImageHeight;
	dgi(imgId).style.position='relative';
	if(maskw/maskh >= imw/imh){
		dgi(imgId).style.width=maskw+'px';
		dgi(imgId).style.height=(imh*maskw/imw)+'px';
		dgi(imgId).style.top=((maskh-(imh*maskw/imw))/2)+'px';
	}
	else{
		dgi(imgId).style.height=maskh+'px';
		dgi(imgId).style.width=(imw*maskh/imh)+'px';
		dgi(imgId).style.left=((maskw-(imw*maskh/imh))/2)+'px';
	}
}


/**
 * TABS
 */
var setSelectedTabIconCode=false;
function selectTab(tabId,rowId){
	setSelectedTabIconCode='tabSetIcon("'+rowId+'","'+tabId+'","'+tabGetIcon(rowId,tabId)+'");';
	tabSetIcon(rowId,tabId,'l');
	fAS(rowId,'tabSelect',tabId);
}
function setSelectedTabIcon(){if(setSelectedTabIconCode) eval(setSelectedTabIconCode); setSelectedTabIconCode=false;}



var tabDx=[];
var tabMinX=[];
var tabTopY=[];

var tabPrevCaption=false;
var tabSelected=[];
var tabOptionsRowId;

function tabPick(tabId, rowId){
	var tabMaxX=0;
	var calcMinX=false;
	if(tabMinX[rowId]==undefined){
		tabMinX[rowId]=9999;
		calcMinX=true;
	}
	var totalWidth=0;
	var nbTabs=dgn('tAb_'+rowId,'all').length;
	for(var i=0;i<dgn('tAb_'+rowId,'all').length;i++){
		t=dgn('tAb_'+rowId,i);
		if(calcMinX && t.offsetLeft<tabMinX[rowId]) tabMinX[rowId]=t.offsetLeft;
		if(t.offsetLeft+t.offsetWidth>tabMaxX) tabMaxX=t.offsetLeft+t.offsetWidth;
		totalWidth+=t.offsetWidth;
		if(tabSelected[rowId]==undefined && t.className=='tabSel') tabSelected[rowId]=t.id.substr(t.id.indexOf('_')+1);
	}
	t=dd.elements[rowId+'_'+tabId];
	if(tabDx[rowId]==undefined){
		if(nbTabs>1) tabDx[rowId]=((tabMaxX-tabMinX[rowId]-totalWidth)/(nbTabs-1)); else tabDx[rowId]=0;
		tabTopY[rowId]=t.y;
	}
	t.maxoffl=t.x-tabMinX[rowId] + ((tabMinX[rowId]==dgi(rowId+'_'+tabId).offsetLeft)?0:dgi(rowId+'_'+tabId).offsetWidth+tabDx[rowId]);
	t.maxoffr=((tabMaxX==dgi(rowId+'_'+tabId).offsetLeft + dgi(rowId+'_'+tabId).offsetWidth)?0:tabMaxX-t.x+tabDx[rowId]);
}

/**
 * Called on tab drop
 */
function tabDrop(tabId, rowId, noSave){
	var arr=[],i,t,pos=tabMinX[rowId],idArr='';
	for(i=0;i<dgn('tAb_'+rowId,'all').length;i++)
		arr.unshift((10000+Math.floor(dgn('tAb_'+rowId,i).offsetLeft+dgn('tAb_'+rowId,i).offsetWidth/2))+'-'+dgn('tAb_'+rowId,i).id);
	arr=arr.sort();

	for(var i=0;i<arr.length;i++){
		nb=arr[i];
		nb=arr[i].substr(arr[i].indexOf('-')+1);
		t=dd.elements[nb];
		if(t){
			t.moveTo(pos,false);
			t.defx=pos;
			pos+=t.w+tabDx[rowId];
			idArr+=','+nb.substr(nb.indexOf('_')+1);;
		}
	}
	if(!noSave) fAS(rowId,'tabSort',idArr.substr(1));
}

function tabSel(tabId, rowId){
	if(tabSelected[rowId]==tabId) return false;
	windowStop();
	for(var i=0;i<dgn('tAb_'+rowId,'all').length;i++){
		t=dgn('tAb_'+rowId,i);
		if(t.id==rowId+'_'+tabId) {
			if(phpBrowser=='ie') t.style.width=(t.offsetWidth+11)+'px';
			t.className='tabSel';
			if(dgi('tabSH_'+rowId)) dgi(rowId+'_'+tabId+'_sh').innerHTML=dgi('tabSH_'+rowId).innerHTML.replace(/ROWID/,rowId);
		}
		else{
			if(phpBrowser=='ie' && t.className!='tab') t.style.width=(t.offsetWidth-11)+'px';
			t.className='tab';
			thisTabId=t.id.substr(t.id.indexOf('_')+1);
			dgi(rowId+'_'+thisTabId+'_sh').innerHTML='';
		}
	}
	dd.recalc();
	tabSelected[rowId]=tabId;
	tabPrevCaption=dgi(rowId+'_'+tabId+'_c').innerHTML;
	dgi('tabOptionsTitle').value=tabPrevCaption;
	tabDrop(tabId, rowId, true);
	return true;
}
function tabCreate(rowId){
	fAS(rowId,'tabCreate');
}
function tabDel(){
	tabOptionsHide();
	var conf=wl.capt.genConfirmSuppress;
	conf=conf.replace(/%1/,dgi(tabOptionsRowId+'_'+tabSelected[tabOptionsRowId]+'_c').innerHTML);
	if(dgi('feedsDiv').innerHTML.length>2 && !confirm(conf)) return;
	fAS(tabOptionsRowId,'tabDel',tabSelected[tabOptionsRowId]);
}
function tabRebuildDragElts(rowId){
	for(var i=0;i<dgn('tAb_'+rowId,'all').length;i++) if(dd.elements[dgn('tAb_'+rowId,i).id]) dd.elements[dgn('tAb_'+rowId,i).id].del(true);
	for(var i=0;i<dgn('tAb_'+rowId,'all').length;i++) ADD_DHTML(dgn('tAb_'+rowId,i).id+HORIZONTAL);
	dd.recalc();
}
function tabEditCaption(){
	W.onkeydown=tabOptionsTitleKD;
}
function tabDoneEditCaption(){
	W.onkeydown=false;
	if(tabPrevCaption!=dgi('tabOptionsTitle').value){
		tabPrevCaption=dgi('tabOptionsTitle').value;
		fAS(tabOptionsRowId,'tabEditCaption',tabSelected[tabOptionsRowId],tabPrevCaption);
	}
}
function tabOptionsTitleKD(e){
	var kc;
	if(e) kc=e.which; else {if(W.event) kc=W.event.keyCode; else return;}
	if(kc==27) dgi('tabOptionsTitle').value=tabPrevCaption;
	if(kc==13 || kc==27) tabOptionsHide();
}
// Show tab options form
function tabOptionsShow(rowId,tabImg){
	if(!tabPrevCaption) {
		tabPrevCaption=dgi(rowId+'_'+tabSelected[rowId]+'_c').innerHTML;
		dgi('tabOptionsTitle').value=tabPrevCaption;
	}
	dd.elements.tabOptionsForm.resizeTo('auto','auto');
	dgi('tabOptionsFormIcon').src=tabGetIcon(rowId,tabSelected[rowId]);
	dd.elements.tabOptionsForm.moveTo(Math.max(hspacing, tabImg.parentNode.parentNode.offsetLeft), tabImg.offsetTop);
	tabOptionsRowId=rowId;
	setScreenMask('tabOptionsHide()');
	dd.elements.tabOptionsForm.maximizeZ();
	dd.elements.tabOptionsForm.show();

	if(dgi('tabIcons').innerHTML=='') {
		var output='';
		for(var i=0;i<tabIcons.length;i++) output+='<a class="buttonSmall" href="#"><img src="/gfx/'+tabIcons[i]+'.png" style="width:16px;height:16px" onclick="tabChangeIcon(\''+rowId+'\',this.src)"></a>';
		dgi('tabIcons').innerHTML=output;
	}
}
function tabOptionsHide(){
	tabDoneEditCaption()
	dd.elements.tabOptionsForm.moveTo(-5000,0);
	dd.elements.tabOptionsForm.hide();
	removeScreenMask();
}
// Change selected tab's icon
function tabChangeIcon(rowId,src){
	dd.elements.tabOptionsForm.hide();
	removeScreenMask();
	fAS(rowId,'tabChangeIcon',tabSelected[rowId],src);
}
// Set/Get tab's icon
function tabSetIcon(rowId,tabId,src){
	if(src=='l') wl.loading.set(rowId+'_'+tabId+'_icon');
	else dgi(rowId+'_'+tabId+'_icon').src=src;
}
function tabGetIcon(rowId,tabId){return dgi(rowId+'_'+tabId+'_icon').src;}