function fTime(secs){
	if(!secs) return '-';
	var h=Math.floor(secs/3600);
	var m=Math.floor(Math.floor((secs%3600))/60);
	var s=Math.floor(secs%60);
	if(h>0 && m<10) m="0"+m;
	if(s<10) s="0"+s;
	if(h>0) return hmsCaption.replace(/%1/,h).replace(/%2/,m).replace(/%3/,s);
	else return msCaption.replace(/%1/,m).replace(/%2/,s);
}

function insertCover(t, img, small){
	if(img.length>0){
		if(sourceType=='iTunes') t=t.replace(/COVERSRC/g,((small)?coverSmallTemplate:coverTemplate).replace(/IMAGEPATH/,img.replace(/#/,lPID)));
		else t=t.replace(/COVERSRC/g,((small)?coverSmallTemplate:coverTemplate).replace(/IMAGEPATH/,img));
	}
	else {
		t=t.replace(/COVERSRC/g,defaultCoverSrc);
	}

	t=t.replace(/EXTRAHTML=""/i,'width="'+Math.floor(2*fvCoverWidth/((small)?2:2))+'" height="'+Math.floor(2*fvCoverWidth/((small)?2:2))+'"');
	return t.replace(/imgtag/gi,'img');
}

// PLAY FUNCTIONS
function playTrack(trackId){
	if(inlinePlayer) fAS(trackId,'view','firstLoad','','async'); else view(trackId,defAudioWidth,defAudioHeight)
}
function playAlbum(artistName, albumName){
	if(inlinePlayer) fAS('album/'+artistName+'/'+albumName,'view','firstLoad','','async'); else view('album/'+artistName+'/'+albumName,defAudioWidth,defAudioHeight)
}
function playArtist(artistName){
	if(inlinePlayer) fAS('artist/'+artistName,'view','firstLoad','','async'); else view('artist/'+artistName,defAudioWidth,defAudioHeight)
}
function playPlaylist(playlistId){
	if(inlinePlayer) fAS('playlist/'+playlistId,'view','firstLoad','','async'); else view('playlist/'+playlistId,defAudioWidth,defAudioHeight)
}

function inlineUpdatePlayerInfo(trackId){fAS(trackId,'inlineUpdatePlayerInfo');}

// PLAYLIST FUNCTIONS
function plAddArtist(artistName){fAS(artistName,'plAddArtist');plBlink()}
function plAddAlbum(artistName, albumName){fAS(artistName,'plAddAlbum',albumName);plBlink()}
function plAddPlaylist(playlistId){fAS(playlistId,'plAddPlaylist');plBlink()}
function plAddTrack(trackId){fAS(trackId,'plAddTrack');plBlink()}
function plAddAllShuffle(){fAS(0,'plAddAllShuffle');plBlink()}
function plBlink(){setTimeout("wl.liBlink(dgi('setViewTools'))",300)}

// FILTER FUNCTIONS
function changeDisplayType(ndt){fAS(ndt,'changeDisplayType');}
function changeItemsPerPage(nb){fAS(nb,'changeItemsPerPage');}
function changeOffset(selectSeq){fAS(selectSeq,'changeOffset');}
function groupBy(item){setTimeout("fAS('"+item+"','changeGroupBy')",500)}
function search(exp){
	searchValue=exp;
	fAS(exp,'search');
}
function validateSearch(){}
function toggleDetail(detailType, artistName, albumName, destId){
	if(!n.innerHTML) showDetail(detailType, artistName, albumName, destId);
	else n.innerHTML='';
}
var detArtN,detAlbN;
function showDetail(detailType, artistName, albumName, destId){
	var n=dgi("det"+destId);
	if(n.innerHTML!='') return;
	dgi("id"+destId).className='liSel';
	detAlbN=D.comForm.data1.value=albumName;fAS(detArtN=artistName,'showDetail', destId, detailType);
	D.comForm.data1.value='*resSpecific*';
}
function updateDatabase(){fAS(false,'updateDatabase',false,false,'sync');}

// Return HTML code for button that adds album to playlist
function plAddAlbumBt(art,alb,showAlb){
	if(!hasPlaylist) return '';
	return tPrep('plAddAlbumBt').replace(/ARTISTNAMEJS/g,art.replace(/'/g,"\\'")).replace(/ALBUMNAMEJS/g,alb.replace(/'/g,"\\'"))+liSep();
}

// INSERT DETAIL VIEW FUNCTIONS
function trackDetail(tD, tN, displayType){
	var trackTemplate;
	if(displayType=='compact') trackTemplate=tDCT; else trackTemplate=tDCF;
	trackTemplate=trackTemplate.replace(/TRACKTIME/,fTime(tD[2])).replace(/TRACKNAME/g,tD[1]).replace(/TRACKID/g,tD[0]);
	if(displayType=='full') trackTemplate=trackTemplate.replace(/ARTISTNAME/,tD[3]).replace(/ALBUMNAME/g,tD[4]);
	if(tN) return trackTemplate.replace(/TRACKNUMBER/,'('+tN+') '); else return trackTemplate.replace(/TRACKNUMBER/,'');
}
function insertDetail(detailType, displayType, destId, data){
	var html=dgi('backButton').innerHTML.replace(/&lt;/g,'<').replace(/&gt;/g,'>');
	if(detailType=='Artist'){
		var albumTemplate,i,o,album,tracksHtml="",aH="",artistName=dgi("name"+destId).innerHTML;

		if(displayType=='displayFull') albumTemplate=aDFT; else albumTemplate=aDCT;
		for(i=0;i<data.length;i++){
			album=data[i];
			aH=albumTemplate.replace(/ITEMID/g,'destId'+i);
			aH=aH.replace(/ALBUMNAMEJS/g,album[0].replace(/'/g,"\\'"));	// foo.replace(/'/g,"\\'"));
			aH=aH.replace(/ALBUMNAME/g,album[0]);
			aH=insertCover(aH,album[1],true);
			aH=aH.replace(/YEAR/,album[2]);
			aH=aH.replace(/TOTALTIME/,fTime(album[3]));
			aH=aH.replace(/NBTRACKS/,album[4]);
			aH=aH.replace(/ARTISTNAMEJS/g,artistName.replace(/'/g,"\\'"));	// foo.replace(/'/g,"\\'"));
			aH=aH.replace(/ARTISTNAME/g,artistName);
			tracksHtml=plAddAlbumBt(artistName,album[0])
			tracksHtml='';
			for(o=0;o<album[5].length;o++){tracksHtml+=trackDetail(album[5][o],o+1,'compact');}
			html+=aH.replace(/TRACKS/,tracksHtml);
		}
	}
	if(detailType=='Album'){
		html+=plAddAlbumBt(detArtN,detAlbN,1);
		for(var o=0;o<data.length;o++){html+=trackDetail(data[o],o+1,'compact');}
		html=gATDCT.replace(/ITEMID/,'destId'+i).replace(/TRACKS/g,html);
	}
	if(detailType=='Playlist'){
		for(var o=0;o<data.length;o++){html+=trackDetail(data[o],o+1,'full');}
		html=gATDCT.replace(/TRACKS/g,html);
	}
	dgi('mainDiv').innerHTML=html;
}

function updateSelect(selectArray){
	var html="";
	var txt="";

	for(var i=0;i<selectArray.length;i++){
		html+='<option value="'+i+'"'+((selectArray[i].substr(0,1)=='S')?' selected':'')+'>'+selectArray[i].substr(1)+'</option>';
	}
	if(selectArray.length>1) return '<select size="1" class="textInput" style="width:100%" onChange="changeOffset(this.value)">'+html+'</select><br/>';
	else return '';
}

// FULL VIEW UPDATE FUNCTIONS
function displayList(groupBy, displayType,  mixedFilter, dataArray, selectArray, currentOffset, replace){
	var html='<table class="liTable" cellspacing=0 cellpadding=0><colgroup><col width="1%"><col width="98%"><col width="1%"></colgroup>';
	var i;

	// Build list HTML
	switch(groupBy){
		case "artist":
			for(i=0;i<dataArray.length;i++) html+=groupByArtist(mixedFilter,dataArray[i],i+currentOffset);
			break;
		case "album":
			for(i=0;i<dataArray.length;i++) html+=groupByAlbum(mixedFilter,dataArray[i],i+currentOffset);
			break;
		case "playlist":
			for(i=0;i<dataArray.length;i++) html+=groupByPlaylist(mixedFilter,dataArray[i],i+currentOffset);
			break;
		case "tracks":
			for(i=0;i<dataArray.length;i++) html+=groupByTrack(mixedFilter,dataArray[i],i+currentOffset);
		default:
	}

	html+='</table>';

	if(replace) mDiv.innerHTML=updateSelect(selectArray)+html;
	else {
		mDiv.innerHTML=((mDiv.innerHTML)?mDiv.innerHTML:updateSelect(selectArray))+html;
	}
	setView('files',0,1);
}
function displayNoResults(){mDiv.innerHTML=dgi("noSearchResult").innerHTML;}

function groupByArtist(displayType, item, index){
	var t;
	if(displayType!='artistCompact') t=gArFT; else t=gArCT;
	if(displayType!='artistCompact') {
		t=dgi("groupByArtistFull").innerHTML;
	}
	else t=dgi("groupByArtistCompact").innerHTML;
	t=t.replace(/&lt;/g,"<").replace(/&gt;/g,">");
	t=t.replace(/ITEMID/g,"Artist"+index);
	t=insertCover(t,item[3],false);
	t=t.replace(/ARTISTNAMEJS/g,item[0].replace(/'/g,"\\'"));	//foo.replace(/'/g,"\\'"));
	t=t.replace(/ARTISTNAME/g,item[0]);
	t=t.replace(/NBTRACKS/,item[2]);
	return t.replace(/NBALBUMS/,item[1]);
}
function groupByAlbum(displayType, item, index){
	var t;
	if(displayType!='albumCompact') t=gAFT; else t=gACT;
	t=t.replace(/ITEMID/g,"Album"+index);
	t=insertCover(t,item[4],false);
	t=t.replace(/ARTISTNAMEJS/g,item[1].replace(/'/g,"\\'"));	//foo.replace(/'/g,"\\'"));
	t=t.replace(/ALBUMNAMEJS/g,item[0].replace(/'/g,"\\'"));	//foo.replace(/'/g,"\\'"));
	t=t.replace(/ARTISTNAME/g,item[1]);
	t=t.replace(/ALBUMNAME/g,item[0]);
	t=t.replace(/TOTALTIME/,fTime(item[3]));
	return t.replace(/NBTRACKS/,item[2]);
}
// "Array(Array('trackId','trackName','albumName','artistName','totalTime1),Array(),...)
function groupByTrack(displayType, item, index){
	var t=tGT.replace(/ITEMID/g,"Tracks"+index);
	t=t.replace(/TRACKID/g,item[0]);
	t=t.replace(/ARTISTNAMEJS/g,item[3].replace(/'/g,"\\'"));	// foo.replace(/'/g,"\\'"));
	t=t.replace(/ALBUMNAMEJS/g,item[2].replace(/'/g,"\\'"));	// foo.replace(/'/g,"\\'"));
	t=t.replace(/ARTISTNAME/g,item[3]);
	t=t.replace(/ALBUMNAME/g,item[2]);
	t=t.replace(/TRACKNAME/g,item[1]);
	return t.replace(/TRACKTIME/,fTime(item[4]));
}
function groupByPlaylist(displayType, item, index){
	var t=gPCT.replace(/ITEMID/g,"Playlist"+index);
	t=t.replace(/PLAYLISTID/g,item[0]);
	t=t.replace(/PLAYLISTNAME/g,item[1]);
	return t.replace(/NBTRACKS/,item[2]);
}
function tPrep(i){return dgi(i).innerHTML.replace(/&lt;/g,"<").replace(/&gt;/g,">")}



var gAFT,gACT,gArFT,gArCT,tGT,gPCT,gATDCT,tDCT,tDCF,aDFT,aDCT,mDiv;
function init(){
	var gB="groupBy",a="Album",r="Artist",f="Full",c="Compact",d="Detail",t="track",l="album";
	gAFT=tPrep(gB+a+f);
	gACT=tPrep(gB+a+c);
	gArFT=tPrep(gB+r+f);
	gArCT=tPrep(gB+r+c);
	tGT=tPrep(t+"Group");
	gPCT=tPrep(gB+"Playlist"+c);
	gATDCT=tPrep(l+"Track"+d+c);
	tDCT=tPrep(t+d+c);
	tDCF=tPrep(t+d+f);
	aDFT=tPrep(l+d+f);
	aDCT=tPrep(l+d+c);
	mDiv=dgi("mainDiv");
	if(eV=='files')	fAS('','refreshDisplay');
}
function setViewIco(){
	if(a=dgi('setViewSearch')) a.className=(eV=='search')?'btSel':'bt';
	if(a=dgi('setViewFiles')) a.className=(eV=='files')?'btSel':'bt';
	if(a=dgi('setViewTools')) a.className=(eV=='tools')?'btSel':'bt';
}
function setView(d,n,nS){
	eV=d;
	setViewIco();
	if(n) wl.liSel(n);
	if(!nS) fAS('','setView',d,'','async');
}
