var buttonEnabled=0, rcUserRightsLinks={}
/**
 * Check if entered value satisfy contraints and do text coloration
 * @param dataName: name of data
 * @return boolean: true if Ok, false if constraints not satisfied
 */
function rcCheckConstraints(dataName, dataValue){
	var ok=1, n=(dgn(dataName+'_apply'))?dgn(dataName+'_apply'):dgn(dataName);
	if(!n) return 0;

	if(n.type!='text' && n.type!='password') return 1; // Only check constraints on text inputs

	if(dataValue===undefined) dataValue=n.value;

	// Check client-side constraints
	if(n.getAttribute('constraints')){
		var c=n.getAttribute('constraints');
		if(c.substr(0,6)=='range:'){
			c=(c.substr(6)).split('-');
			if(isNaN(dataValue) || 1.0*dataValue < 1.0*c[0] || 1.0*dataValue > 1.0*c[1]) ok=0;
		}
		else if(c.substr(0,7)=='length:'){
			c=(c.substr(7)).split('-');
			if(dataValue.length < 1.0*c[0] || dataValue.length > 1.0*c[1]) ok=0;
		}
		else ok=((new RegExp(c.substr(6))).test(dataValue));

		// Colorize
		n.style.color=(ok)?'':'red';
		if(ok||n.value!=='') $(n).e.className().remove('invalid'); else $(n).e.className().add('invalid');
	}
	return ok;
}

/**
 * Called when a data has been modified by user
 */
function eSaveBt(dataName,dataValue,justCheck){
 	if(window[dataName+"_changed"]) if(window[dataName+"_changed"](dataValue)=='cancel') return;

	if(dataName=='name'){
		if(parent && parent.resourceNameModified) parent.resourceNameModified(dgn('resourceConfigFilename',0).value, dataValue);
		// Propagate event to other frames
		var n=dgn('resourceConfigFilename',0); if(!n) n=dgn('config',0);
		n=n.value;
		wl.event.emit("resource",{"rename":1,"filename":n,"name":dataValue,'id':W.rID})
	}
	var n=(dgn(dataName+'_apply'))?dgn(dataName+'_apply'):dgn(dataName);

	// Special: detect focus lost on pwd to uncheck
	if(dataName=='directResourceAccessPassword' && !dataValue && !dgn('directResourceAccessPassword').focused) dgn('directResourceAccessPasswordHas').click();

	// If value is not modified,
	if(!W.syncData) W.syncData={}
	if(syncData[dataName]!==undefined && syncData[dataName]===dataValue) return;

	// Check if value is ok
	ok=rcCheckConstraints(dataName, dataValue);
	if(justCheck||!ok) return;

	syncData[dataName]=dataValue;

	// Direct access enabled/disabled toggle
	if(dataName=='directResourceAccessEnabled')	{
		//dgi('directResourceAccessConfig').className='extendedInfo'+((dataValue)?'':'2');
		$('directResourceAccessParams').e.verticalFadeInOut(dataValue,200)
		//dgi('directResourceAccessParams').style.display=(dataValue)?'block':'none';
	}
	// Toggle password for direct resource access
	if(dataName=='directResourceAccessPasswordHas')	{
		dgn('directResourceAccessPassword').disabled=(dataValue)?false:"disabled";
		$(dgn('directResourceAccessPassword')).e.setAlpha((dataValue)?1:0.5);
		// If webDAV can be enabled, toggle webDAV password
		if(dgi('webDAVParams')){
			$('webDAVPasswordInput').style.display=(dataValue)?'':'none';
			$('webDAVPasswordNo').style.display=(dataValue)?'none':'';
		}
	}

	// Change password for direct resource access
	if(dataName=='directResourceAccessPassword')	{
		if(dgi('webDAVParams')) $('webDAVPasswordInput').value=dataValue;
	}

	// Toggle direct resource access LAN restriction controls when direct resource access is enabled/disabled
	if(dataName=='directResourceAccessEnabled') $('directResourceAccessLanOnlyBlock').style.visibility=(dataValue)?'visible':'hidden'
	if(dataName=='directResourceAccessLanOnly') dgi('webDAVInternetLink').style.display=((dataValue)?'none':'');
	// Direct access enabled/disabled toggle
	if(dataName=='webDAVEnabled'){
		if(dgn('webDAVShowDetail').checked) {
			$('webDAVParams').e.verticalFadeInOut(dataValue,100);
			//$('webDAVGroup').e.className().remove('frame3');
			//if(dataValue) $('webDAVGroup').e.className().add('frame3'); else $('webDAVGroup').e.className().remove('frame3');
		}
		$('webDAVDetail').style.display=(dataValue)?'':'none';
	}
	// Toggle webDAV detail
	if(dataName=='webDAVShowDetail'){
		if(!dgn('webDAVEnabled').checked) return false;
		$('webDAVParams').e.verticalFadeInOut(dataValue,100);
		//if(dataValue) $('webDAVGroup').e.className().add('frame3'); else $('webDAVGroup').e.className().remove('frame3');
		$('webDAVShowDetailShow').style.display=(dataValue)?'none':'';
		$('webDAVShowDetailHide').style.display=(dataValue)?'':'none';
	}

	// Resource config specific actions
	if(W.dataChanged) {
		// if "dataChanged" function returns false, don't save
		if(dataChanged(dataName,dataValue)===false){
			wl.button.disable('saveButton');
			wl.button.enable('cancelButton');
			buttonEnabled=1;
			return;
		}
	}

	if(!buttonEnabled){
		wl.button.enable('cancelButton');
		wl.button.enable('saveButton');
		buttonEnabled=1;
	}

	// If in application resource config tab, always save
	if(W.isApp) save(1);
}

function dataApply(dataName){
	dgn(dataName).value=dgn(dataName+'_apply').value;
	eSaveBt(dataName,dgn(dataName).value)
}
function dataChangedNV(dataName){
	var item=dgn(dataName);
	if(!item) return;
	if(item.type=='checkbox') dataValue=item.checked;
	else if(item.type=='radio') {
		var items=D.getElementsByName(dataName)
		for(var i=0;i<items.length;i++) if(items[i].checked) dataValue=items[i].value;
	}
	else dataValue=item.value;

	if(W.dataChanged) dataChanged(dataName,dataValue);
}

/**
 * Toggle an item of a multi items list. Called by onchange event on checkboxes
 */
function rcToggleMultiListItem(dataName,dataId,value){
	var v=rcMultiLists[dataName],p=rcMultiLists[dataName].indexOf(dataId);

	// 1st remove value from list
	if(p!=-1) {
		v=v.substr(0,p)+v.substr(p+dataId.length+1);
		if(v.substr(v.length-1,1)==';') v=v.substr(0,v.length-1);
	}

	// And append at end of list if needed
	if(value) {
		if(v.length>0) v+=';';
		v+=dataId;
	}
	rcMultiLists[dataName]=v;
	dgi(dataName).value=v;
	eSaveBt(dataName,v)
}

/**
 * Return an array with data from raw text concatenated data
 * @param string dataName
 * @return {'range':,'display':,'items':[]}
 */
function rcUserRightsArray(dataName){
	var items=[],v=dgn(dataName).value.split(';'),i;
	for(i=2;i<v.length;i++) items.push(v[i]);
	return {'range':v[0],'display':v[1],'items':items}
}

/**
 * Save an user rights data
 * @param string dataName
 * @param dataArray {'range':,'display':,'items':[]}
 */
function rcUserRightsSave(dataName,dataArray){
	var prev=dgn(dataName).value,v=dataArray.range+';'+dataArray.display,i, masterDataName;


	for(i=0;i<dataArray.items.length;i++) v+=';'+dataArray.items[i];
	dgn(dataName).value=v;
//alert('save '+v)
	if(v!=prev) {
		eSaveBt(dataName,v);
		// Check if any other rights item is linked to this data
		if(masterDataName=rcUserRightsLinks[dataName.replace(/userRights_/,'')]) rcUserRightsLinkApply('userRights_'+masterDataName,dataName);
	}
}

/**
 * Click on main user rights checkbox to enable or disable all groups
 */
function rcToggleUserRights(dataName,checked){
	var ur=rcUserRightsArray(dataName)

	ur.range=(checked)?'all':'none';
	if(checked) dgi(dataName+'_radio_all').checked=true; else dgi(dataName+'_radio_none').checked=true;
	$(dataName+'_det').innerHTML='';
	rcUserRightsSave(dataName,ur);
}

/**
 * Click on advanced options control to show / hide those options
 */
function rcToggleUserRightsDisplay(dataName){
	var ur=rcUserRightsArray(dataName),r=ur.range,d=ur.display,n=$(dataName+'_bi');

	//if(d!='check' && r!='all' && r!='none') return;
	// Unfold
	if(d=='check'){
		if(ur.range=='list') d='list'; else d='radio';
		$(dataName+'_list').style.display=(d=='list')?'':'none';
		$(dataName+'_options').e.verticalFadeInOut(1,150);
		$(dataName+'_outer').e.className().add('unfolded');
	}
	// Fold
	else{
		d='check';
		$(dataName+'_options').e.verticalFadeInOut(0,150);
		dgn(dataName+'_check').disabled=false;
		$(dataName+'_outer').e.className().remove('unfolded');
	}

	n.src="/gfx/"+((d=='check')?'groupsPlus.png':'groupsMinus.png')
	//$(n).e.setOpacity((d=='check'||r=='all'||r=='none')?1:0.3)

	dgn(dataName+'_check').disabled=(d=='check')?false:true;

	ur.display=d;

	rcUserRightsSave(dataName,ur);

	// Update folded detail
	rcUserRightsUpdateDetail(dataName);
}


/**
 * Click on an option item (none / all / admin / list) or on a group;
 */
function rcToggleUserRightsItem(dataName,id,checked){
	var ur=rcUserRightsArray(dataName),d=ur.display,r=ur.range,n,items=[],i;

	// Click on "none", "all" or "admin" options
	if(id=='none' || id=='all' || id=='admin'){
		if(r=='list') $(dataName+'_list').e.verticalFadeInOut(0,150);
		ur.display='radio';
		ur.range=id;
	}

	// Click on "list" option
	else if(id=='list'){
		if(r!='list') $(dataName+'_list').e.verticalFadeInOut(1,150);
		ur.display='list';
		ur.range=id;
	}

	// Click on a group
	else {
		var found=0,it;
		// Build items list (add or remove clicked item)
		for(i=0;i<ur.items.length;i++){
			it=ur.items[i];
			if(it==id) found=1;
			if(checked || it!=id) items.push(it);
		}
		if(checked && !found) items.push(id);
		ur.items=items;
	}
	//$(dataName+'_bi').e.setOpacity((ur.range=='all'||ur.range=='none')?1:0.3)
	// Commit those changes to main checkbox
	dgn(dataName+'_check').checked=(id!='none')
	dgn(dataName+'_check').disabled=true;
	rcUserRightsSave(dataName,ur);
}



/**
 * Update user rights data display according to it's value
 * Used to update display of a data when it has been automatically modified because a linked data has been modified too
 */
function rcUserRightsUpdateItemDisplay(dataName){
	var ur=rcUserRightsArray(dataName),r=ur.range,d=ur.display,n=$(dataName+'_bi'), found, i, e, cb;
	var det=$(dataName+'_det');
	det.innerHTML='';

	if(r=='all' || r=='none'){
		dgn(dataName+'_check').checked=(r=='all');
		if(d=='list'){
			$(dataName+'_options').style.display=='none';
			ur.display='check';
			d='radio';
		}
		if(r=='all') $(dataName+'_radio_all').checked=1; else $(dataName+'_radio_none').checked=1;

	}
	if(r=='admin'){
		dgn(dataName+'_check').checked=1;

		$(dataName+'_radio_admin').checked=1;
		$(dataName+'_options').style.display=='block';
		ur.display='radio';
	}
	if(r=='list'){
		dgn(dataName+'_check').checked=1;
		$(dataName+'_radio_list').checked=1;
		ur.display='list';

		$(dataName+'_list').e.verticalFadeInOut(1,150);

		cb=dgi(dataName+'_list').getElementsByTagName('input');

		for(e=0;e<cb.length;e++){
			id=cb[e].id.substr(cb[e].id.lastIndexOf('_')+1);
			found=0;
			for(i=0;i<ur.items.length;i++) if(ur.items[i]==id) found=1;
			cb[e].checked=found;
		}
	}
	n.src="/gfx/"+((d=='check')?'groupsPlus.png':'groupsMinus.png')
	//$(n).e.setOpacity((d=='check'||r=='all'||r=='none')?1:0.3)
	dgn(dataName+'_check').disabled=(d=='check')?false:true;

	rcUserRightsUpdateDetail(dataName)
}

/**
 * Update folded (check) right details span when range is "admin" or "list"
 * @param string dataName
 */
function rcUserRightsUpdateDetail(dataName){
	var ur=rcUserRightsArray(dataName),r=ur.range,d=ur.display,n=$(dataName+'_bi'), i, tmp;

	var det=$(dataName+'_det');
	if(ur.display!='check' || (ur.range!='admin' && ur.range!='list')) return det.innerHTML='';
	if(ur.range=='admin') return det.innerHTML=' ('+wl.capt.photoCfgCEAdmin+')';
	tmp='';
	for(i=0;i<ur.items.length;i++){
		try{
			tmp+=', '+dgi(dataName+'_item_input_'+ur.items[i]).nextSibling.nextSibling.nodeValue;
		}
		catch(e){}
	}
	det.innerHTML=((tmp)?' ('+tmp.substr(2)+')':'');
}
/**
 * Indicate an user right needs another one to be set to work
 * Called once on page load
 *
 * masterDataName: name of data required by slave
 * slaveDataName: name of data that needs master data rights to be at least equal to work
 */
function rcUserRightsLink(masterDataName, slaveDataName){rcUserRightsLinks[slaveDataName]=masterDataName}
function rcUserRightsLinkApply(masterDataName, slaveDataName){
	//alert('align '+masterDataName+' on '+ slaveDataName)
	var mur=rcUserRightsArray(masterDataName), sur=rcUserRightsArray(slaveDataName),sr,mr,i,o,found=0;
	sr=sur.range;
	mr=mur.range;
	// If slave request rights on all groups, apply to master as well
	if(sr=='all') mur.range='all';
	// if(sr=='none') {} // If slave request no rights, leave master alone
	else if(sr=='admin'){
		if(mr=='none') mur.range='admin';
		if(mr=='list') {
			for(i=0;i<mur.items.length;i++){
				if(mur.items[i]==rcUserRightsAdminId) found=1;
			}
			if(!found) mur.items.push(rcUserRightsAdminId);
		}
	}
	else if(sr=='list'){
		if(mr=='none'){
			mur.range='list';
			mur.items=[];
			for(i=0;i<sur.items.length;i++) mur.items.push(sur.items[i]);
		}
		if(mr=='admin'){
			mur.range='list';
			mur.items=[rcUserRightsAdminId];
			mr='list'; // Turn admin into a list item so it's processed by next lines
		}
		if(mr=='list'){
			for(i=0;i<sur.items.length;i++) {
				id=sur.items[i];
				found=0;
				for(o=0;o<mur.items.length;o++) if(mur.items[o]==id) found=1;
				if(!found) mur.items.push(id);
			}
		}
	}
	//cfDbg(mur)
	rcUserRightsSave(masterDataName,mur);
	rcUserRightsUpdateItemDisplay(masterDataName);
}


/**
 * IE display issue workaround: groups div is not displayed at first page rendering unless height is explicitely set
 */
function rcUserRightsItemInit(dataName){var n=$(dataName+'_list'); n.style.height=n.offsetHeight+'px'}

/**
 * Async update of users linked to resource
 * @param array newList: new list of linked users
 */
function rcUserRightsUpdatedUsers(newList){
	var i,o,n,id,found;
	n=D.getElementsByName('rcUserRightsItem');
	for(i=0;i<n.length;i++) {
		nid=n[i].parentNode.id;
		id=nid.substr(0,nid.lastIndexOf('_'));
		id=id.substr(id.lastIndexOf('_')+1);
		found=0;
		for(o=0;o<newList.length;o++) if(newList[o]==id){found=1;break}
		$(nid).e.setAlpha((found)?1:0.3);
	}
}

function toggleAdvancedConfig(){
	var ac=!dgn("advancedConfig").checked;
	dgn("advancedConfig").checked=ac;
	$('advancedConfigDiv').e.verticalFadeInOut(ac,200);
	dgi('advancedConfigOuter').className='advancedConfig'+((ac)?'Unfolded':'Folded');
	dgi('advancedConfigUnfoldBt').style.display=(ac)?'block':'none';
	dgi('advancedConfigFoldBt').style.display=(ac)?'none':'block';
	save(1);
}
function rcShowIconForm(show){
	wl.UIWebPopup('/local/uiResources/iconResource.php?currentIcon='+dgn('customIcon').value+'&resType='+rcType+'&resSubType='+rcSubType,rcChangeIconCB)
}
function rcChangeIconCB(newIcon){
	$("resIconImg").e.setSrc((newIcon!='0')?'/gfx/res/'+newIcon+'.png':defaultResIcon);
	dgn("customIcon").value=newIcon;
	save(1);
	try{parent.updateResourceIcon(dgn("resourceConfigFilename").value,(newIcon!='0')?'/gfx/res/'+newIcon+'_16.png':defaultResIconSmall)} catch(e){}
}

// Save / apply changes
function save(async,fromBt){
	if(!rcButtonLessConfig && !fromBt) return;

	if(async) asyncSubmitForm('configForm');
	else{
		for(e in dgn('configForm').getElementsByTagName('input')) {e=dgn('configForm').getElementsByTagName('input')[e] ;if(e.disabled) e.disabled=false};
		for(e in dgn('configForm').getElementsByTagName('select')) {e=dgn('configForm').getElementsByTagName('select')[e] ;if(e.disabled) e.disabled=false};
		D.configForm.submit()
	}
}





/**
 * Resource config - Files & folders drop list management
 */
function scrollBottom(){dgi("sharedItemsDropBox").scrollTop=dgi("sharedItemsDropBox").scrollHeight}
function basename(cfn){
	if(cfn.lastIndexOf('/')==cfn.length-1) cfn=cfn.substr(0,cfn.length-1);
	return cfn.substr(cfn.lastIndexOf('/')+1);
}

function sharedMode_changed(val){
	dgi('sharedModeList').style.display=(val=='folder')?'none':'inline';
	dgi('sharedModeFolder').style.display=(val=='folder')?'block':'none';
	D.getElementsByName('sharedMode')[1].checked=(val!='folder'); //WA
	sharedMode=val;

	//IE bug WA
	if(dgi("advancedConfigDiv")) {
		with(dgi("advancedConfigDiv").style){overflow=(overflow=='hidden')?'':'hidden';	overflow=(overflow=='hidden')?'':'hidden';}
	}
}
// Called on file drop over files list or folder share
function filesDropped(){
	var items=dgn('dropFileInput').value;dgn('dropFileInput').value='';
	if(!items) items=$('path').value;

	// Files list
	if(dgi('sharedModeList').style.display!='none')	filesAdd(items);

	// Single folder (ensure only one item has been dropped and it's a directory)
	else if(items.indexOf('|')==-1 && items.substr(0,2)=='d:') {
		$('path').value=items.substr(2);
		eSaveBt('path',$('path').value);
	}
}
function filesClearList(){
	dgi('sharedItemsDropBox').innerHTML='';
	dgn('sharedItems').value='';
	fillEmpty();
	if(W.save) save(1);
	if(W.rcSharedFilesBoxUpdated) rcSharedFilesBoxUpdated('');
}

/**
 * Add files from a drag & drop action to a resources files list
 * @param str: list of files & folders, separated by | . Each file is prepended by 'f:', directories are prepended by 'd:'
 */
function filesAdd(str){
	if(!str) return;

	var items=str.replace(/\\/g,'/').split('|'); /* IDE syntax analysis WA comment */
	var prevItems=dgn('sharedItems').value;
	if(!prevItems) prevItems=[]; else prevItems=prevItems.split('|');

	var pIL={}, output='',ext , itemTypes=[];

	// Retrieve files list
	for(var i=0;i<prevItems.length;i++) pIL[basename(prevItems[i])]=prevItems[i];
	// Add new files
	for(var i=0;i<items.length;i++) {
		// Guess if it's a file or a directory from 2 first chars
		if(items[i].substr(0,2)!=='d:' && items[i].substr(0,2)!=='f:') items[i]='f:'+items[i];
		itemTypes[i]=((items[i].substr(0,2)==='d:')?'dir':'file');
		items[i]=items[i].substr(2);

		if(!pIL[basename(items[i])]) {
			if(extFilter && itemTypes[i]=='file'){
				ext=items[i].substr(items[i].lastIndexOf('.')+1).toLowerCase();
				// if dir or allowed extension, add
				if(items[i].lastIndexOf('.')<=items[i].lastIndexOf('/') || extFilter[ext]) pIL[basename(items[i])]=items[i];
			}
			else pIL[basename(items[i])]=items[i];
		}
	}

	items=''; for(var e in pIL) items+='|'+pIL[e]; dgn('sharedItems').value=items.substr(1);

	scrollBottom();

	if(W.save) save(1); else filesOfflineUpdate(pIL)

	if(W.rcSharedFilesBoxUpdated) rcSharedFilesBoxUpdated(dgn('sharedItems').value);
}
var filesRemoveTO=0;
function filesRemove(n){
	if(filesRemoveTO) clearTimeout(filesRemoveTO); filesRemoveTO=0;
	n=n.parentNode; cfn=n.id;
	var n2=n.nextSibling;
	n.parentNode.removeChild(n);
	while(n2){
		if(n2.className=='odd') n2.className='even';
		else if(n2.className=='even') n2.className='odd';
		else break;
		n2=n2.nextSibling;
	}
	var items='',prevItems=dgn('sharedItems').value;
	if(!prevItems) prevItems=new Array(); else prevItems=prevItems.split('|');
	for(var i=0;i<prevItems.length;i++) if(prevItems[i]!=cfn) items+='|'+prevItems[i];
	dgn('sharedItems').value=items.substr(1);
	filesRemoveTO=setTimeout("save(1)",1500);
	fillEmpty();
	if(W.save) save(1);
	if(W.rcSharedFilesBoxUpdated) rcSharedFilesBoxUpdated(dgn('sharedItems').value);
}
function fillEmpty(){
	var n=dgi("sharedItemsDropBox").firstChild;
	if(!n) {
		dgi("sharedItemsDropBox").innerHTML='<div class="even">&nbsp;</div>'
		n=dgi("sharedItemsDropBox").firstChild;
	}
	var nb=0;
	while(1){
		if(n.className=='odd'||n.className=='even') nb++;
		if(!(n=n.nextSibling)) break;
	}
	var out='';
	while(nb++<8) out+='<div class="'+((nb%2)?'even':'odd')+'">&nbsp;</div>';
	html=dgi("sharedItemsDropBox").innerHTML;

	dgi("sharedItemsDropBox").innerHTML=html+out;
}
function lTt(n){return '<span style="white-space:nowrap">'+n.parentNode.id+'</span>'}
function filesOfflineUpdate(items){
	var item,o='',nb=0;
	var WM=dgi("sharedItemsDropBox").innerHTML;
	WM=WM.substr(WM.indexOf('<CENTER'));
	for(var i in items){
		item=items[i];
		o+='<div class="'+((nb%2)?'odd':'even')+'" id="'+item+'"><img src="/gfx/eraser.png" onclick="filesRemove(this)" style="vertical-align:bottom;cursor:pointer"><img src="/ext/fileIcon.php?size=16&ext='+item.substr(item.lastIndexOf('.')+1)+'" class="ico2"><span onmouseover="tooltip(this,lTt(this))">'+item.substr(item.lastIndexOf('/')+1)+'</span><br clear="all"></div>';
		nb++;
	}

	while(nb<8) {
		o+='<div class="'+((nb%2)?'odd':'even')+'">&nbsp;</div>';
		nb++;
	}
	dgi("sharedItemsDropBox").innerHTML=o;
}

/**
 * Reset file / folder input color on key press if the key modify the content
 * @param e: event
 * @param n: input node
 */
function rcResetColor(e,n){
	kc=wl.eventKC(e);
	if(kc!=45 && kc!=33 && (kc<16 || kc>18) && (kc<33 || kc>40)) n.style.color='';
}


// Open mailout configuration form in a popup
function rcMailoutConfigure(){
	wl.UIWebPopup('/local/mailConfigForm.php?mainConfiguration=1',rcMailoutConfigureCB)
}
// Called when mailout popup is closed
function rcMailoutConfigureCB(res){if(res='reload') wl.goURL()}


/**
 * User-configuration-only scripts (no advanced config)
 */

// Bind user context menu
function createUnboundUsersCM(unboundUsers){
	var items=new Array(),i=0,e;
	for(e in unboundUsers){
		items[i]=ContextMenuItem(unboundUsers[e]["icon"],unboundUsers[e]["name"],"bindUser('"+e+"')");
		i++;
	}
	ContextMenuAttach(dgi('showUnboundUsersBt'),items,{'align':'right','leftClick':1,'button':1,'style':{'width':130}})
}
// Bind user to resource (in app only)
function bindUser(uid){parent.toggleUser(rcResourceFilename,uid)}
// Unbind user from resource (in app only)
function unbindUser(uid){parent.toggleUser(rcResourceFilename,uid)}
// Show users panel and select user
function UIShowUser(uid){wl.UICommand('showUser:'+uid)}

// Add a new value to data array
function rcArrayItemAdd(dataName){
	var v=dgn(dataName).value,n=dgi(dataName+'_input').value;
	if(!n) return;
	v+=((v)?'	':'')+n;
	dgn(dataName).value=v;
	eSaveBt(dataName,v);
}
// Remove an item from data array (item at position k)
function rcArrayItemRemove(dataName,k){
	var v=dgn(dataName).value,s=v.split('	'),nv='';
	for(i=0;i<s.length;i++) if(i!=k) nv+=((nv)?'	':'')+s[i];
	dgn(dataName).value=nv;
	eSaveBt(dataName,nv);
}