<?php
/**
 * Show statistiques
 *
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

// Initialize script data
require_once('localFunctions.php');
lfInit();

// If signle user history requested: get statistics database connection id
if(isset($_GET['sessionId']) && cfIsInApp()){
	$sessionFile=cfAppDataDir().'/sessionData/sess_'.$_GET['sessionId'];
	if(!is_file($sessionFile)){
		cfInsertHEAD();
		die('<body onload="wl.UICommand(\'close\')"></body>');
	}
	$monitoredSession=@unserialize(file_get_contents($sessionFile));

	// get dbId (id of last record inserted into "connection" table)
	$dbId=$monitoredSession['weezoGeneral']['dbId'];

	// Check if user has a chat resource
	if(is_array($monitoredSession['res']))foreach ($monitoredSession['res'] as $res) {
		if(@$res['type']=='webcam' && @$res['subType']=='chat' && @$res['id']){
			$chatResourceFilename=cfArrayItem(cfMGetVar('weezoResourcesList'),$res['id']);
			break;
		}
	}

	$infoType='single';
}
else $infoType='list';

// Create a resource context so fiGetInfo can be used
cfRCreateFakeResource();

/**
 * Insert page header, except for async requests, and thumbnails images
 */
if(!isset($_POST['asyncRequest']) && !isset($_GET['thumbnail'])){
	// Insert page <head> and <body>
	cfInsertHEAD(false,array(
		'size'=>(isset($_GET['sessionId']) && !cfGGetVar('historyLogViewedContent'))?'600x500':'800x500',
		'icon'=>'log',
		'title'=>APPLICATION_NAME.' - '.cfCaption('genHistory'))
	);
	echo cfScriptLink('winClient.js');
?>
<style type="text/css">
.cell{padding:4px 0px 4px 0px}
.dcell{padding:4px 0px 4px 0px;filter:Alpha(opacity=50, style=0); -moz-opacity:0.50; -khtml-opacity:0.50; opacity:0.50;}
</style>
</head>
<body oncontextmenu="return false">
	<?php
	// Insert drag & drop stuff for tooltips
	echo cfScriptLink('wz_dragdrop.js');
}

/**
 * Include history scripts
 */
require_once(INCLUDE_DIR.'databaseFunctions.php');
require_once(INCLUDE_DIR.'../res/administration/std/stats.php');

// End of page stuff
if(!cfIsAsync()) {
	echo cfDragRegisterItems(false,true);
	echo '</body></html>';
}
?>