<?php

/**
 * @desc Return data for server block
 *
 * @return array(title,content,action)
 */
function uiConfigBlockServer(){
	$title=outImage(outIcon('configServer'),false,false,'vertical-align:top;margin-right:1em').cfCaption('mainServer');
	$content='<div style="position:absolute;width:100%;top:50%;margin-top:-1em;left:0">';
	$content.=cfCaption('configServerPort').', UPnP, SSL, '.cfCaption('bittorrent').', '.cfCaption('genStatus').', '.cfCaption('activityLogs').'...';
	$content.='</div>';
	$content.=outImage(outIcon('UI/configUp'),false,false,'position:absolute;right:10px;top:10px');
	$action="showFrame('server',0,-1)";

	return array('title'=>$title,'content'=>$content,'action'=>$action);
}


/**
 * @desc server parameters configuration items
 *
 */
function uiConfigFrameServer(){
	global $resourceData;

	echo outDivframe('frame1');

	// Server status (online or online, LAN) (only compute on sync display to save CPU)
	$status=cfCaption('apacheStartedWeb').outHelpTag(cfCaption('startServerWebDet'));
	if(!cfIsAsync())  $onLan=strpos(file_get_contents(cfAppDataDir().'/httpd.conf'),'#onLAN');
	if(@$onLan) $status=cfCaption('apacheStartedLocal').outHelpTag(cfCaption('startServerLocalDet'));
	$status.=outImageIcon('ok',false,'margin-left:0.5em');

	// Restart button
	$serverButtons=outBt(cfCaption('adminRestart'),outIcon('reload2'),"javascript:uiConfigWaitMask();wl.UICommand('serverRestart')",false,false,'style="margin-left:2em"');
	// Start on web button
	if(@$onLan) $serverButtons.=outBt(cfCaption('adminRestart').' ('.cfCaption('configServerStartModeWeb').')',outIcon('web'),"javascript:uiConfigWaitMask();wl.UICommand('serverStartWeb')",false,false,'style="margin-left:2em"');
	// Start on LAN button
	else $serverButtons.=outBt(cfCaption('adminRestart').' ('.cfCaption('configServerStartModeLocal').')',outIcon('LAN'),"javascript:uiConfigWaitMask();wl.UICommand('serverStartLocal')",false,false,'style="margin-left:2em"');

	// Server icon and status
	?>
	<div class="frame1Header"><?php
	uiConfigAdvancedConfigButton('server');
	echo outImage(outIcon('configServer'),false,false,'margin-right:0.5em;vertical-align:bottom;cursor:pointer');
	echo '<fieldset>'.cfCaption('mainServer').'<br><span style="color:black;font-size:80%"><b>'.cfCaption('genStatus').cfCaption('genSeparator').'</b>'.$status.'</span></fieldset>';
	echo $serverButtons;
	?>
	</div>
	<?php
	echo outConfigSeparator();

	if(@$resourceData['UPnPEnabled'] && @$resourceData['UPnPMappingOK']) $UPnPState='ok';
	elseif(@$resourceData['UPnPEnabled']) $UPnPState='nok';
	else $UPnPState='n/a';


	// UPnP mapping
	echo '<div style="position:absolute;top:3px;right:130px">';
	echo outImageIcon('upnp');
	rcProcessData('UPnPEnabled',dataBoolean,true,false,cfCaption('UPnPUse'),false,false);
	echo outImageIcon('ok','id="UPnPOK"','visibility:'.(($UPnPState=='ok')?'visible':'hidden'));
	echo outImageIcon('loading','id="UPnPLoading"','visibility:hidden');
	echo '</div>';

	echo '<br>';

	// UPnP failure warning
	echo '<div class="extendedWarning" style="text-align:center;display:'.(($UPnPState=='nok')?'block':'none').';margin-bottom:0.4em" id="UPnPWarning">'.outImageIcon('warning').'<b>'.cfCaption('UPnPFailed').'</b><br>'.cfCaption('UPnPFailedDetail').'</div>';


	// MAIN SERVER PORT
	echo '<div class="extendedInfo2" style="margin-bottom:0.4em;margin-top:4em"><br><span class="frame2Header">';
	rcProcessData('serverPort',dataNumeric, cfGGetVar('serverPort'), array(1,65535), array(cfCaption('configServerPort'),2), false, false,array('apply'=>1));
	echo '</span>';
	rcProcessData('automaticServerPortSelection',dataBoolean, true, array(1,65535), cfCaption('genAutomatic'), false, false,array('apply'=>1));
	echo '<span style="margin-right:4em"></span>';

	// SSL
	echo cfCaption('configSecureWithSSL');
	rcProcessData('protocol',dataList, cfGGetVar('protocol'), array('http','https'),array(
			array(false,'https',cfCaption('genYes')),
			array(false,'http',cfCaption('genNo'))
		)
		,false, false);
	echo '<br>&nbsp;</div><br>';

	// BitTorrent seeder config
	echo outImageIcon('bittorrent');
	rcProcessData('bittorrentEnabled',dataBoolean,true,false,cfCaption('bittorrent'),false,false);
	rcProcessData('bittorrentPort',dataNumeric, 6996, array(1,65535), array(cfCaption('genPort'),2), true, false,array('apply'=>1));

	echo '<br><br><br><br>';

	/***************************************************************************************************************************
	 *  Advanced config section
    ***************************************************************************************************************************/
	echo uiConfigAdvancedFrameHeader('server');

		// Server start mode
		rcProcessData('defaultServerState',dataList,'web',array('web','local'),array(
			array(false,cfCaption('configServerStartMode')),array(
			array('web',cfCaption('configServerStartModeWeb')),
			array('local',cfCaption('configServerStartModeLocal'))
		),false),false);

		echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';

		// LAN perimeter
		rcProcessData('httpdLANFilter',dataText, '192.168.0.0/255.255.0.0 10.0.0.0/255.0.0.0', false, array(cfCaption('genFilter'),15), false, false);

		// Alternate server port SSL
		rcProcessData('httpdLANFilterAuto',dataBoolean,true,false,cfCaption('genAuto'),false);
		echo '<br>';

		// Alternate server port
		rcProcessData('alternateServerPort',dataNumeric,0,array(0,65535),array('<b>'.cfCaption('alternatePort').'</b> (0-65535)',3,' '),false,false,array('apply'=>1));

		// Alternate server port SSL
		rcProcessData('alternateServerPortSSL',dataBoolean,((cfGGetVar('alternateServerPort')==443)?false:true),false,'<b>SSL</b>',false);

		// IP restrictions
		echo '&nbsp;&nbsp;&nbsp;&nbsp;'.outBt(cfCaption('configIPFilter'),outIcon((cfIPFilterIsset())?'stop':'ahead'),"javascript:wl.UICommand('webPopup:/local/IPFilter.php');").'<br><br>';

		// Pages compression
		rcProcessData('webPagesCompressionLevel',dataNumeric, 0, array(0,9), array(cfCaption('acWebPagesCompressionLevel'),1), true, false);
		echo '<br>';

		// SSL
		echo outDivFrame('frame3');
		echo '<div class="frame3Header">SSL</div>';

		// Regenerate SSL certificate
		echo outBt(cfCaption('configGenerateCertificate'),outIcon('certificate'),"javascript:wl.UICommand('generatesslcertificate')").'<br><br>';

		// Generate SSL certificate according to server's IP
		rcProcessData('useIPForSSLCertificate',dataBoolean,true,false,cfCaption('useIPForSSLCertificate'));
		echo '</div><br>';

		// Cipher password on non-SSL connection
		rcProcessData('encryptPassword',dataBoolean,true,false,cfCaption('configEncryptPasswords'));


		// HTTPD compatibility mode
		rcProcessData('httpdCompatibilityMode',dataBoolean, false, false, cfCaption('acHttpdCompatibilityMode'),true, false);

		// Apache and PHP version (VC6 or VC9)
		if(WEnv::host()->isWindows()) {
			echo '<b>PHP & Apache &nbsp;</b>';
			rcProcessData('useVC9Executables',dataBoolean, false, false, array('PHP 5.4 (XP SP3, Vista, 7)','PHP 5.2 (XP)'), false, false);
		}
		// PHPinfo
		echo outBt('PHP - '.cfCaption('genInfos').' - phpinfo()',outIcon('php'),'javascript:wl.UICommand(\'webPopup:/local/uiConfig.php?command=phpInfo\');');

		echo '<br>';
		echo '<br>';

		// Server crash monitoring by Weezo
		rcProcessData('serverCrashMonitor',dataBoolean, true, false, cfCaption('acServerCrashMonitor'), false, false);
		echo '&nbsp;&nbsp;&nbsp;';
		// Weezo crash monitoring by server
		rcProcessData('weezoCrashMonitor',dataBoolean, true, false, cfCaption('acWeezoCrashMonitor'), true, false);

		// File / memory : display only if sessionHandler was memory
		if(isset($resourceData['sessionHandler']) && $resourceData['sessionHandler']=='memory'){
			echo dataTitle('Apache session handler</b><br>"Memory" session handling should be more efficient (faster and less disk access) but is quite unstable and might cause unexpected disconnections<b>');
			rcProcessData('sessionHandler',dataList,'file',array('file','memory'),array(
			array(false,cfCaption('sessionHandler')),array(
			array('file','file '),
			array('memory','memory')
			),false),true);
		}

		// OpCode Caching (APC/XCache/eaccelerator)
		/*
		echo '<br>';
		rcProcessData('serverOpCodeCache',dataList,'APC',array('XCache','APC','no'),array(
			array(false,'OpCode Cache'),array(
			array('XCache','XCache'),
			array('APC','APC'),
			array('no',cfCaption('genDisabled'))
			),false),false);
		*/
		echo 'OpCode Cache <select class="textInput" disabled><option value="foo">';
		if(function_exists('apc_fetch')) echo 'APC ';
		if(function_exists('xcache_get')) echo 'XCache ';
		echo '</option></select>&nbsp;';
		if(function_exists('apc_fetch')) echo outBt(cfCaption('genStats'),outIcon('stats'),"javascript:wl.UICommand('webPopup:/local/uiConfig.php?command=APCStats');",'apcStatsBt',false,false,(extension_loaded('apc'))?'up':'off');



		echo '<br><br>';

		// Error log
		rcProcessData('phpLogErrors',dataBoolean, true, false, cfCaption('acPhpLogErrors'),false, false);
		if($resourceData['phpLogErrors'] && file_exists(cfAppLogDir().'/'.PHP_ERRORS_LOG_FILE)) echo outBt(cfCaption('genSend'),false,'/local/submitErrorReport.php',false,false,'style="vertical-align:middle"');
		echo '<br>';
		rcProcessData('phpHideErrors',dataBoolean, false, false, cfCaption('acPhpHideErrors'), true, false);


		echo '<br>';

		rcProcessData('turnOffApacheAtExit',dataBoolean, false, false, cfcaption('acTurnOffApacheAtExit'), true, false);

		/**
		 * MySQL
		 */
		if(cfMySQLInstalled()){
			echo '<br>'.outDivFrame('frame3').'<div class="frame3Header">MySQL</div>';
			rcProcessData('mysqlPort',dataNumeric, 3306, array(1,65535), array(cfCaption('configServerPort'),1), true, false);
			echo '</div>';
		}

		// Logs
		echo '<br>'.outDivFrame('frame3').'<div class="frame3Header">'.cfCaption('activityLogs').'</div>';
		echo '<span style="white-space:nowrap;margin-right:3em">';
		rcProcessData('apacheAccessLog',dataBoolean, false, false, 'HTTPD (Apache) access log', false, false);
		echo '<a href="javascript:void(wl.asr.send({\'command\':\'viewLog\',\'logName\':\''.HTTPD_ACCESS_LOG_FILE.'\'}))" class="link">'.cfCaption('genSee').'</a>';
		echo '</span>';

		echo '<span style="white-space:nowrap;margin-right:3em">';
		rcProcessData('apacheErrorLog',dataBoolean, false, false, 'HTTPD (Apache) error log',false , false);
		echo '<a href="javascript:void(wl.asr.send({\'command\':\'viewLog\',\'logName\':\''.HTTPD_ERRORS_LOG_FILE.'\'}))" class="link">'.cfCaption('genSee').'</a>';
		echo '</span>';

		echo '<span style="white-space:nowrap">';
		rcProcessData('historyLogViewedContent',dataBoolean, false, false, cfCaption('historyLogContent'), false, false);
		rcProcessData('historyLogViewedContentDays',dataNumeric, 365, array(0,999999), array(1,cfCaption('genDays')), true, false);
		echo '</span>';
		rcProcessData('fileLogMaxSize',dataNumeric,500000,array(1000,9999999999),array(cfCaption('acFileLogMaxSize'),5, 'KB'),true,false);
		echo '</div>';


	echo '</div>'; // Advanced config end
	echo '</div>'; // Server frame end
}



/**
 * @desc Display phpinfo() page
 *
 */
function uiConfigPhpInfoPage(){
	ob_start();
	phpinfo();
	$out=ob_get_clean();
	$meta=cfUIMeta('size','700x600',true).cfUIMeta('title','phpinfo()',true);
	echo str_replace('</head>',$meta."\n</head>",$out);
	exit;
}
