<?php
/**
 * User Interface community tab
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.2.0
 */
$mainMenuTree=1;

//if(!cfIsAsync()) cfDbgUrl();

/**
 * @desc Display OSX-style main left-side menu
 *
 */
function uiMainMenuTree(){
	global $tabs;

	$tree=array('ico'=>outIcon('resources'),'path'=>'top','label'=>'','sub'=>array());
	$folding=cfExplode2Levels('/',':',cfGGetVar('uiMainMenuTreeFolding'));

	// Add send and publish links
	if(!cfSimpleMode()){
		// Insert into array
		foreach ($tabs as $id=>$tab){
			$extendedTabs[$id]=$tab;
			if($id=='resource'){
				$extendedTabs['send']=array('label'=>cfCaption('publishDownloadLabel'),'ico'=>false,'script'=>'uiResources.php?tab=send');
				$extendedTabs['publish']=array('label'=>cfCaption('publishResourceLabel'),'ico'=>false,'script'=>'uiResources.php?tab=publish');
			}
			if($id!='resource' && $id!='user' && cfGGetVar('selectedTab')==$id) $extendedTabs[$id]['selected']=true;
		}
	}
	// Simple mode: add send and configuration
	else {
		// Insert into array
		foreach ($tabs as $id=>$tab){
			$extendedTabs[$id]=$tab;
			if($id=='resource'){
				$extendedTabs['send']=array('label'=>cfCaption('publishDownloadLabel'),'ico'=>false,'script'=>'uiResources.php?tab=send');
				$extendedTabs['config']=array('label'=>cfCaption('mainConfigButton'),'ico'=>false,'script'=>'uiConfig.php');
			}
		}
	}

	// Create top level
	foreach ($extendedTabs as $tabId=>$tab)
		$tree['sub'][$tabId]=array(
			'ico'=>false,//$tab['ico'],
			'label'=>cfStrToUpper($tab['label']),
			'sub'=>array(),
			'selected'=>((
				($tabId!='resource' && $tabId!='user' && cfGGetVar('selectedTab')==$tabId)
				)?true:false),
			'tag'=>$tab['script'],
		)
		+((isset($folding[$tabId]) && $folding[$tabId])?array():array('unfolded'=>true));

	// Users
	if(!cfSimpleMode()){
		foreach (WEnv::userConfigs() as $user){
			if(0) $user=new WUserConfig();
			$tree['sub']['user']['sub'][$user->id()]=array(
				'label'=>cfUTF8Encode($user->getVar('name')),
				'ico'=>$user->altIconPath(),
				'selected'=>(cfGGetVar('selectedTab')=='user' && $user->id()===cfGGetVar('uiUsersSelectedId')),
				'rightClickFunction'=>'uiMain.mainMenuRightClick',
				//'ico'=>cfExtGFX('/gfx/icons/'.$user->getVar('icon'),16,16),
				'sub'=>array()
			);
		}
		// New user button
		//$tree['sub']['user']['outerLabel']='<span class="treeViewBt" '.outToolTip(cfCaption('userNewUser'),false,false,true).' onclick="uiMainMenuTree.newUser();">+</span>';
		$tree['sub']['user']['outerLabel']='<span class="treeViewBtAdd" '.outToolTip(cfCaption('userNewUser'),false,false,true).' onclick="uiMainMenuTree.newUser();"></span>';
	}
	// Resources
	foreach (WEnv::resConfigs() as $config){
		if(0) $config=new WResConfig();

		$tree['sub']['resource']['sub'][$config->id()]=array(
			'label'=>cfUTF8Encode($config->name()),
			'selected'=>(cfGGetVar('selectedTab')=='resource' && $config->filename()===cfGGetVar('uiResourceSelected')),
			//'ico'=>$config->uiIcon16(),
			'ico'=>$config->icon16(),
			'sub'=>array()
		);
	}

	// New resource button
	$tree['sub']['resource']['outerLabel']='<span class="treeViewBtAdd" '.outToolTip(cfCaption('resNewResource'),false,false,true).' onclick="uiMainMenuTree.newResource()"></span>';

	// configurations
	if(!cfSimpleMode()){
		$tree['sub']['config']['sub']['general']=array('label'=>cfCaption('configApplication'),'ico'=>outIcon('gears'),'sub'=>array());
		$tree['sub']['config']['sub']['theme']=array('label'=>cfCaption('configAppearance'),'ico'=>outIcon('theme'),'sub'=>array());
		$tree['sub']['config']['sub']['server']=array('label'=>cfCaption('mainServer'),'ico'=>outIcon('server'),'sub'=>array());
		$tree['sub']['config']['sub']['misc']=array('label'=>cfCaption('genMisc'),'ico'=>outIcon('configMiscS'),'sub'=>array());
		foreach ($tree['sub']['config']['sub'] as $k=>$v) $tree['sub']['config']['sub'][$k]['ico']=$v['ico'];
		/*
		$tree['sub']['config']['sub']['general']=array('label'=>cfCaption('configApplication'),'ico'=>outIcon('UI/uiGeneralSmall'),'sub'=>array());
		$tree['sub']['config']['sub']['theme']=array('label'=>cfCaption('configAppearance'),'ico'=>outIcon('UI/uiThemeSmall'),'sub'=>array());
		$tree['sub']['config']['sub']['server']=array('label'=>cfCaption('mainServer'),'ico'=>outIcon('UI/uiServerSmall'),'sub'=>array());
		$tree['sub']['config']['sub']['misc']=array('label'=>cfCaption('genMisc'),'ico'=>outIcon('UI/uiMiscSmall'),'sub'=>array());
		*/
		// Desaturate icons
		//foreach ($tree['sub']['config']['sub'] as $k=>$v) $tree['sub']['config']['sub'][$k]['ico']=cfFilteredImage($v['ico'],0,0,array('r'=>36,'g'=>101,'b'=>130,'p'=>50),255,255);
	}


	/*
	$treeView->rightClickFunction='treeRightClick';
	*/
	$treeView=new treeView('uiMainMenuTree');
	$treeView->phpTree=$tree;
	$treeView->selectFunction='uiMainMenuTree.nodeClick';
	$treeView->toggleFoldFunction='uiMainMenuTree.changeFolding';
	$treeView->noATag=true;
	//$treeView->rightClickFunction='uiMain.mainMenuRightClick';

	// Async call: just update
	if(cfIsAsync()){
		echo cfAsyncJSaction($treeView->HTMLUpdate());
		return;
	}

?>
<script type="text/javascript">
var uiMainMenuTree={
	'nodeClick':function(n){
		var p=n.getPath().split('/'),type=p[1],id=p[p.length-1];

		// Top-level access
		if(n.tag()) {
			if(type=='resource'||type=='user') n.toggleFold();
			else{
				n.setSelected();
				uiMain.tabSelect(n.tag(),type)
			}
		}

		// Resources / users
		else{
			n.setSelected();
			if(type=='user') uiMain.tabSelect(n.parentNode().tag()+'?userSelectedId='+id,type)
			if(type=='resource') uiMain.tabSelect(n.parentNode().tag()+'?tab=share&resSelectedId='+id,type)
			if(type=='config') uiMain.tabSelect('uiConfig.php?tab='+id,type)
		}
		return false;
	},

	// Tree folding changed
	'changeFolding':function(node){
		var tn=node.treeView().baseNode().childrenNodes(),n,o='',p;
		//cfDbg(tn.baseNode().childrenNodes())
		for(e in tn) {
			//cfDbg(tn[e])
			if(typeof tn[e]=='object'){
				n=new treeNode(tn[e])
				p=n.getPath();
				o+=(o?'/':'')+p.substr(p.lastIndexOf('/')+1)+':'+(n.isFolded()?1:0);
			}
		}
		sendData('uiMainMenuTreeFolding='+o)
	},
	// Create new resource button clicked: sync load uiResources, that will load share/share.php iFrame, that will launch createResource javascript function
	// Note: classical IFrame src method must be used, or else event propagation and other stuff would fail (probable IE bug)
	'newResource':function(){
		uiMain.tabSelect('uiResources.php?tab=share&createResource','resource',1)
	},
	// Create new user
	// Note: classical IFrame src method must be used, or else event propagation and other stuff would fail (probable IE bug)
	'newUser':function(){
		if(uiMain.selectedTab=='user')
			frames.uiMainIFrame.uiUserCreate();
		else
			uiMain.tabSelect('uiUsers.php?uiUserCreateNewUser=1','user',1)
	},
	// Update tree element from event happening in a lower iframe (user / resource creation/rename/deletion)
	'update':function(args){
		// Rename resource / user
		if(args.rename){
			try{treeViews.uiMainMenuTree.getNodeById(args.id).setLabel(args.name)} catch(e){}
		}
		// Deleted or created resource / user
		else wl.asr.send({'uiMainMenuTreeUpdate':1})
	}
}
wl.event.subscribe("resource",uiMainMenuTree.update);
wl.event.subscribe("user",uiMainMenuTree.update);
</script>
<div id="uiTreeViewOuterDiv" style="width:100%;height:100%;overflow:auto;overflow-x:hidden">
<?php
echo $treeView->HTML(false,false,false,'overflow:visible !important;overflow-x:hidden;height:1px !important');
?>
</div>
<?php
}

/**
 * @desc Return an array of tabs
 *
 * @return array
 */
function uiMainTabs(){
	$tabs=array(
		'start'=>array(
			'label'=>cfCaption('mainStartButton'),
			'script'=>'uiStart.php',
			'icon'=>outIconApp(16)
		),
		'user'=>array(
			'label'=>cfCaption('genGroups'),
			'script'=>'uiUsers.php',
			'icon'=>outIcon('groups')
		),
		'resource'=>array(
			'label'=>cfCaption('genResources'),
			'script'=>'uiResources.php',
			'icon'=>outIcon('resources2')
		),
		'community'=>array(
			'label'=>cfCaption('genCommunity'),
			'script'=>'uiCommunity.php',
			'icon'=>outIcon('users')
		),
		'activity'=>array(
			'label'=>cfCaption('mainActivityButton'),
			'script'=>'uiActivity.php',
			'icon'=>outIcon('stats')
		),
		'config'=>array(
			'label'=>cfCaption('mainConfigButton'),
			'script'=>'uiConfig.php',
			'icon'=>outIcon('gears')
		)
	);

	if(cfSimpleMode()){
		unset($tabs['start']);
		unset($tabs['user']);
		unset($tabs['community']);
		unset($tabs['activity']);
	}
	return $tabs;
}

/**
 * @desc Insert a button for opening the UI into a browser (debug)
 *
 */
function uiMainDebugButton(){
	if(cfGGetVar('UIDebug')) echo outBt(false,outIcon('bugs'),'javascript:void(W.open(D.location))',false,false,' style="position:absolute;top:2px;left:2px"');
}


/**
 * @desc Display site address area
 *
 */
function uiMainSiteAddress(){
	if(cfSimpleMode()) return;
?>
<div id="uiMainSiteAddressArea">
	<?php echo cfCaption('yourSiteAddress'); ?>&nbsp;
	<input id="uiMainSiteAddress" value="<?php echo cfPublicURL(); ?>" readonly="readonly" onclick="this.select()">&nbsp;<br>
	<div id="uiMainSiteSocial" style="display:none">
		<?php echo outSocialURLShare(cfPublicURL(),array(),APPLICATION_NAME); ?>
	</div>
</div>
<!-- <div id="uiMainSiteVersion"><?php echo cfGGetVar('appVersion');?></div> -->
<?php
}

/**
 * @desc Display profile edition button
 *
 */
function uiMainProfileButton(){
	// Windows: use application form
	if(WEnv::host()->isWindows())
		echo outBt(cfCaption('configAccountEdit'),outIcon('appIcon16'), "javascript:wl.UICommand('openProfile')",'uiMainProfileButton');
	// Linux / OSX: use HTML form
	else
		echo outBt(cfCaption('configAccountEdit'),outIcon('appIcon16'),'javascript:wl.UIWebPopup(\'/local/registrationForm.php\',false,{\'width\':490,\'height\':440})','uiMainProfileButton',false);
}

/**
 * @desc Display "server online on port X" label
 *
 */
function uiMainSiteOnlineLabel(){
?>
<div id="uiMainSiteOnlineLabel">
<?php echo cfCaption((cfMGetVar('weezoServerState')=='lan')?'apacheStartedLocal':'apacheStartedWeb'); ?>
&nbsp;<span style="font-size:80%">(<?php echo cfGGetVar('serverPort'); ?>)</span>
</div>
<?php
}

/**
 * @desc Display application status
 *
 */
function uiMainStatus(){?>
<div id="uiMainStatus"><?php
if(cfMGetVar('uiMainStatus')) {
	list($icon,$text,$displayProfileFormLink)=explode('|',cfMGetVar('uiMainStatus'));
	echo '<img src="'.$icon.'" style="vertical-align:bottom;margin-right:0.7em">'.$text;
	if($displayProfileFormLink) echo '<img src="'.outIcon('gears').'" style="vertical-align:bottom;margin-left:1em;cursor:pointer" onclick="uiMain.editProfile()">';
}
?></div><?php
}

/**
 * @desc Connection to site button
 *
 */
function uiMainSiteConnect(){
	if(!cfSimpleMode()) echo outBt(cfCaption('genSitePreview'),false,"javascript:uiMain.siteConnect('".cfLocalhostName()."')",'uiMainSiteConnectButton',false);
	//if(!cfSimpleMode()) echo outBt(cfCaption('genSitePreview'),false,cfLocalhostName().'" target="blank','uiMainSiteConnectButton',false);
}

/**
 * Reduce/expand bottom banner button
 *
 */
function uiMainBannerToggleButton(){
	echo '<div onclick="uiMain.toggleBanner()" id="uiMainBottomBannerToggleBt"'.outToolTip(cfCaption('winMaximize').' / '.cfCaption('winMinimize')).'></div>';
}

/**
 * @desc Donate button
 *
 */
function uiMainDonate(){
	$reg=cfRegistrationData();
	$accountName=@$reg['regName'];

	// Localize donate button
	$srcImg='UI/donate-'.cfGGetVar('language').'.png';
	if(!file_exists(cfAppDocRoot().'/gfx/'.$srcImg)) $srcImg='UI/donate.png';

	echo outImage(outIcon($srcImg),APP_SITE.'/redirect.php?item=donate&account='.$accountName,' target="_blank" id="uiMainDonate"','display="'.((cfGGetVar('registration'))?'none':'').'"');
}

/**
 * @desc Display caption for online users and necessary div's for left-side animation
 *
 */
function uiMainSiteOnlineUsers(){
	$ext=(cfBGetVar('name')==='IE6')?'.gif':''; // Force gif image if IE6 as png are not supported
	//$ext='.gif';
?>
<div id="uiMainOnlineUsersGroup">
<?php echo outImage(outIcon('uiMainOnlineUsersGfx'),false,'id="uiMainOnlineUsersGfx"'); ?>
<div id="uiMainOnlineLocalhostLinks" style="background:url(<?php  echo outIcon('uiMainOnlineLocalhostLinks'.$ext);?>)"></div>
<div id="uiMainOnlineLanLinks" style="background:url(<?php  echo outIcon('uiMainOnlineLanLinks'.$ext);?>) 0 0 no-repeat"></div>
<div id="uiMainOnlineWebLinks1" style="background:url(<?php  echo outIcon('uiMainOnlineWebLinks'.$ext);?>) 0 0 no-repeat"></div>
<div id="uiMainOnlineWebLinks2" style="background:url(<?php  echo outIcon('uiMainOnlineWebLinks'.$ext);?>) 0 0 no-repeat"></div>
<div id="uiMainOnlineLocalhost"></div>
<div id="uiMainOnlineLan">LAN<span></span></div>
<div id="uiMainOnlineWeb"><?php echo cfCaption('genInternet');?><span></span></div>
</div>
<div id="uiMainOnlineUsersLabel"><?php echo cfCaption('mainNumberConnectedUsers','<span id="uiMainOnlineUsersTotal"></span>&nbsp;'); ?></div>
<?php
}

/**
 * @desc Echo script for updating display of connected users (work sync & async)
 *
 */
function uiMainUpdateConnectedUsers(){
	$lhost=0; $lan=0; $web=0;
	foreach (WEnv::usersLogged()->getUsers() as $loggedUser){
		if(0) $loggedUser=new WUserLogged();
		if($loggedUser->range=='localhost') $lhost++;
		elseif($loggedUser->range=='lan') $lan++;
		else $web++;
	}
	if(cfIsAsync()) echo cfAsyncJSaction('W.uiMain.updateConnectedUsers('.($lhost).','.($lan).','.($web).')');
	//if(cfIsAsync()) echo cfAsyncJSaction('W.uiMain.updateConnectedUsers('.$lhost.','.$lan.','.$web.')');
	else echo 'uiMain.updateConnectedUsers('.$lhost.','.$lan.','.$web.');';
}

/**
 * Process POST commands
 *
 */
function uiMainProcessPost(){
	global $tabs;
	if (cfIsAsync()){
		cfAsyncHeader();
		if(isset($_POST['selectedTab']) && isset($tabs[$_POST['selectedTab']])) cfGUpdateVar('selectedTab',$_POST['selectedTab']);
		if(isset($_POST['requestConnectedUsersUpdate'])) uiMainUpdateConnectedUsers();

		// Update status set in bottom banner (status is passed by UI to javascript so it needs to be stored by PHP to be able to re-display it in case of page refresh
		// Note: status is also updated through server command in case UI is not displayed/responsives
		if(isset($_POST['uiMainUpdateStatus']) && isset($_POST['text']) && isset($_POST['iconURI']) && isset($_POST['displayProfileFormLink']) && is_numeric($_POST['displayProfileFormLink'])){
			cfMSetVar('uiMainStatus',$_POST['iconURI'].'|'.$_POST['text'].'|'.$_POST['displayProfileFormLink']);
		}

		// Memorize  uiMainMenuTree folding
		if(isset($_POST['uiMainMenuTreeFolding'])) cfGUpdateVar('uiMainMenuTreeFolding',$_POST['uiMainMenuTreeFolding']);

		// Async update menu tree
		if(isset($_POST['uiMainMenuTreeUpdate'])) uiMainMenuTree();

		// Memorize  bottom banner reduced/expanded
		if(@$_POST['toggleBanner']) cfGUpdateVar('uiBannerReduced',((cfGGetVar('uiBannerReduced'))?0:1));

		// Reorder group's resources (code copied from uiUsers.php)
		if(isset($_POST['userOrder'])){
			$users=cfUsersConfigs();
			$no=array();
			foreach (explode(',',$_POST['userOrder']) as $uid) if(isset($users[$uid])) $no[]=$users[$uid]->filename();
			cfGUpdateVar('users',implode(',',$no),true,true);
		}
		die(cfAsyncFooter());
	}
}


/**
 * @desc Insert Javascript
 *
 */
function uiMainScripts(){
	?>
<script type="text/javascript">
var uiMain={
	'selectedTab':'<?php echo cfGGetVar('selectedTab');?>',
	'connected':{'localhost':-1,'lan':0, 'web':0},
	'linksImg':{'localhost':'uiMainOnlineLocalhostLinks','lan':'uiMainOnlineLanLinks', 'web1':'uiMainOnlineWebLinks1', 'web2':'uiMainOnlineWebLinks2'},
	'linksCapt':{'localhost':dgi('uiMainOnlineLocalhost'),'lan':dgi('uiMainOnlineLan').firstChild.nextSibling, 'web':dgi('uiMainOnlineWeb').firstChild.nextSibling},
	'linksImgH':{},
	'animStep':0,
	// Initialize stuff
	'init':function(){
		winResized();
		setTimeout(winResized,10);
		setTimeout(winResized,1000);

		for(var e in uiMain.linksImg) {
			n=dgi(uiMain.linksImg[e]);
			uiMain.linksImg[e]=n;
			uiMain.linksImgH[e]=n.offsetHeight;
		}
		setInterval(uiMain.updateView,100);
		setInterval(uiMain.requestConnectedUsersUpdate,4000);
		$('uiMainBottomBanner').e.connect('mouseenter',function(){uiMain.socialShow(1)});
		$('uiMainBottomBanner').e.connect('mouseleave',function(){uiMain.socialShow(0)});
	},
	/**
	 * Animate localhost/lan/web links and connected users
	 */
	'updateView':function(forceUpdate){
		var c=uiMain.connected, s, s2, st = uiMain.animStep++;
		if(c.localhost || forceUpdate){
			s=uiMain.linksImg.localhost;
			s.style.visibility=(c.localhost>0 && st%12<6)?"visible":"hidden";
			if(forceUpdate) uiMain.linksCapt.localhost.innerHTML=(c.localhost)?"("+c.localhost+")":"";
		}
		if(c.lan || forceUpdate){
			s=uiMain.linksImg.lan;
			h=uiMain.linksImgH.lan;
			if(c.lan==0) s.style.backgroundPosition="0 0";
			else s.style.backgroundPosition="0 "+(-(st%3+1)*h)+"px";
			if(forceUpdate) uiMain.linksCapt.lan.innerHTML=(c.lan)?" ("+c.lan+")":"";
		}
		if(c.web || forceUpdate){
			s =uiMain.linksImg.web1;
			s2=uiMain.linksImg.web2;
			h =uiMain.linksImgH.web1;
			if(c.web==0) s.style.backgroundPosition=s2.style.backgroundPosition="0 "+(-(<?php if(cfMGetVar('weezoServerState')=='lan') echo 4; else echo 3; ?>)*h)+"px";
			else s.style.backgroundPosition=s2.style.backgroundPosition="0 "+(-(st%3)*h)+"px";
			if(forceUpdate) uiMain.linksCapt.web.innerHTML=(c.web)?" ("+c.web+")":"";
		}
	},

	// Right click on user
	'mainMenuRightClick':function(id){
		if(id.indexOf('/user/')>0){
			var node=$(id),isFirst=(node.previousSibling)?0:1,isLast=(node.nextSibling)?0:1;
			var uiMainUserCMI=[];
			if(!isFirst) uiMainUserCMI.push(ContextMenuItem('<?php echo outIcon('up');?>','<?php echo cfCaptionJS('genUp');?>',"uiMain.groupMove('"+id+"','up')"));
			if(!isLast) uiMainUserCMI.push(ContextMenuItem('<?php echo outIcon('down');?>','<?php echo cfCaptionJS('genDown');?>',"uiMain.groupMove('"+id+"','down')"))

			var cm=new ContextMenu(uiMainUserCMI);

		}
	},
	'groupMove':function(tnId,dir){

		var node=$(tnId),pNode=node.parentNode,ids='';

		// Move node in tree
		if(dir=='up') pNode.insertBefore(node,node.previousSibling)
		else pNode.insertBefore(node.nextSibling,node)

		// Generate new ordered list
		node=pNode.firstChild;
		while(node){
			ids+=','+node.id.substr(node.id.indexOf('/user/')+6);
			node=node.nextSibling;
		}
		wl.asr.send({'userOrder':ids});
	},

	// Toggle bottom banner display
	'toggleBanner':function(){
		$('uiMainBottomBanner').e.className().toggle('reduced')
		winResized();
		wl.asr.send({'toggleBanner':1});
	},

	/**
	 * Select a tab
	 */
	'tabSelect':function (script,tabId,forceClassicalIFrameSrcUpdate){
		// Update tab's url
		$('uiMainIFrame').e.updateIFrameSrc("/local/"+script,forceClassicalIFrameSrcUpdate)
		//alignBottom(dgi('uiMainIFrame'),winMe,$('uiMainBottomBanner').offsetHeight);
		uiMain.selectedTab=tabId;
		wl.asr.send({'selectedTab':tabId});
	},
	// Set UPnP mapping / unmapping result: 1=mapping ok, 0=mapping nok, -1=unmapping ok
	'setUPnPStatus':function(success){
		if(uiMain.selectedTab=='config') frames.uiMainIFrame.uiConfigSetUPnPState(success);
	},
	// Update connected users in bottom banner
	'updateConnectedUsers':function (localhost,lan,web){
		var forceUpdate=0, c=uiMain.connected;
		dgi('uiMainOnlineUsersTotal').innerHTML=(1*localhost+1*lan+1*web);
		if(c.localhost!=localhost || c.lan!=lan || c.web!=web) forceUpdate=1;
		uiMain.connected={'localhost':localhost,'lan':lan, 'web':web}
		if(forceUpdate) uiMain.updateView(1);
	},
	// Update connected users animation in bottom banner
	'requestConnectedUsersUpdate':function(){
		wl.asr.send({'requestConnectedUsersUpdate':'1','noDebug':1})
	},
	// Update application status in bottom banner
	'setStatus':function(txt,iconURI,displayProfileFormLink){
		var html=((iconURI)?'<img src="'+iconURI+'" style="vertical-align:bottom;margin-right:0.7em">':'')+txt;
		if(displayProfileFormLink) html+='<img src="<?php echo outIcon('config3');?>" style="vertical-align:bottom;margin-left:1em;cursor:pointer" onclick="uiMain.editProfile()">';
		dgi('uiMainStatus').innerHTML=html;
		wl.asr.send({'uiMainUpdateStatus':1,'text':txt,'iconURI':iconURI,'displayProfileFormLink':displayProfileFormLink});
	},
	'setUtf8Status':function(txt,iconURI,displayProfileFormLink){
		uiMain.setStatus(txt,iconURI,displayProfileFormLink);
	},
	// Show / hide site's URL social buttons
	'socialShow':function(show){
		if(show) $('uiMainSiteSocial').e.fadeIn(100);
		else $('uiMainSiteSocial').e.fadeOut(100);
		//$('uiMainSiteSocial').style.display=((show)?'block':'none')
	},
	// Connect-to-site button
	'siteConnect':function(url){wl.UICommand('goUrl:'+url)},
	'hideDonateButton':function(){$("uiMainDonate").style.display="none"},
	// Click on an edit profile link
	'editProfile':function(){
		btClick('uiMainProfileButton');
	},
	'propagateScript':function(script,tabName){
		if(selectedTab==tabName) frames.uiMainIFrame.eval(script);
	},
	// webBrowser control display redraw bug workaround
	'redrawDisplay':function(){
		dgi("redrawMask").style.display="";
		setTimeout('dgi("redrawMask").style.display="none"',100);
	},
	// Forward commands from UI to right iframe
	forwardUICommand:function(){
		// Get var name and value
		var n, dataName=dgi("UIReturnVarName").value, dataValue=dgi("UIReturnValue").value;
//alert(dataName+'=>'+dataValue)
		// webBrowser control display redraw bug workaround
		if(dataName=='UIRefreshCmd') return uiMain.redrawDisplay();

		var f=frames.uiMainIFrame;
		frames.uiMainIFrame.wl.UIResultInject(dataName,dataValue);
	},
	'injectPopupResult':function(dataName,dataValue){
		frames.uiMainIFrame.wl.UIResultInject(dataName,dataValue);
	}
}

// Forward UPnP update request from browser
function uiConfigSetUPnPState(ok){uiMain.setUPnPStatus(ok)}

// Set bottom banner status (uiMain.xxx cannot be called from VB)
function uiMainSetStatus(txt,ico,displayProfileFormLink){uiMain.setStatus(txt,ico,displayProfileFormLink)}

// Window resized
function winResized(){
	alignBottom($('uiMainIFrame'),winMe,$('uiMainBottomBanner').offsetHeight);
	alignBottom($('uiTreeViewOuterDiv'),$('uiMainIFrame'));
}
<?php
echo cfDragRegisterItems('SCROLL',false);
?>
</script>
<?php
}

require_once(INCLUDE_DIR.'outputFunctions.php');

if(!cfIsInApp() && !WEnv::user()->isAdministrator()) die('unauthorized access');

$tabs=uiMainTabs();

/**
 ***************************************************************************************************************************
 * Process POST commands
 ***************************************************************************************************************************
 */
uiMainProcessPost();

// Display selected tab
$selectedTab=@$tabs[cfGGetVar('selectedTab')];
if(!$selectedTab) $selectedTab=@$tabs['start'];		// Tab doesn't exist, display start panel
if(!$selectedTab) $selectedTab=@$tabs['resource'];	// Simple mode: start panel doesn't exist => display resources panel

/**
 ***************************************************************************************************************************
 * Insert page HEADER
 ***************************************************************************************************************************
 */
cfInsertHEAD(false);
echo cfScriptLink('winClient.js');
?>
<style type="text/css">
</style>
</head>
<body style="margin:0;padding:0;overflow:hidden">
<?php echo
cfScriptLink('wz_dragDrop.js');

/**
 * Top buttons
 */
?>
<div id="uiMainButtons" style="width:100%;white-space:nowrap;overflow:hidden">
<?php

// Special: config tab in simple mode has no caption and is placed on the right
if(cfSimpleMode()){
	$id='config';
	$tab=$tabs['config'];
		echo outBlockItem('mainButtons',outImage($tab['icon'],false,"onclick=\"uiMain.tabSelect('".$tab['script']."','".$id."')\"",'margin-right:1em;margin-left:4px;vertical-align:bottom;cursor:pointer'),false,'width:26px !important;width:20px;float:right',array('onclick'=>"uiMain.tabSelect('".$tab['script']."','".$id."')"),(cfGGetVar('selectedTab')==$id)?'sel':'unsel');
	unset($tabs['config']);

	//echo '<span id="simpleModeCaption">'.outImage(outIcon('info2'),false,false,'vertical-align:top;margin:-1px 0.5em 0 0').cfCaption('simpleMode').'</span>';
}
// Display tabs
foreach ($tabs as $id=>$tab) {
	echo outBlockItem('mainButtons',outImage($tab['icon'],false,false,'margin-right:1em;margin-left:4px;vertical-align:bottom').$tab['label'],false,false,array('onclick'=>"uiMain.tabSelect('".$tab['script']."','".$id."')"),(cfGGetVar('selectedTab')==$id)?'sel':'unsel');
}
?>
</div>
<?php

/**
 * Bottom banner
 */
?>
<div id="uiMainBottomBanner" class="<?php if(cfGGetVar('uiBannerReduced')) echo 'reduced'; ?>">
	<div id="uiMainBottomBannerShadow"></div>
<?php uiMainDebugButton();?>
<?php uiMainSiteAddress();?>
<?php uiMainProfileButton();?>
<?php uiMainSiteOnlineLabel();?>
<?php uiMainSiteOnlineUsers();?>
<?php uiMainStatus();?>
<?php uiMainSiteConnect();?>
<?php uiMainDonate();?>
<?php uiMainBannerToggleButton();?>
</div>
<?php

/**
 * Main area
 */
echo outTableTransparent(false,'table-layout:fixed','id="uiMainTable"');
?>
	<tr><td id="uiMainMenuFrame" class="uiLeftFrame">
	<img src="<?php echo outIcon('about')?>" style="position:absolute;top:10px;left:155px;cursor:pointer" onclick="wl.UIWebPopup('/local/uiConfig/credits.php')" <?php echo outToolTip(cfCaption('mainAbout'),false,false,true);?>>
<?php
if(cfSimpleMode()) echo '<br><br>';// Simple mode: leave space so add resource button doesn't collide with credits button

// Insert javascript
uiMainScripts();

// Main menu tree
uiMainMenuTree();
?>
	</td>
	<td style="vertical-align:top">
		<iframe name="uiMainIFrame" id="uiMainIFrame" src="/local/<?php echo $selectedTab['script']; ?>" style="width:100%;border:0;padding:0;margin:0" frameborder=0></iframe>
	</td></tr>
</table>

<input type="hidden" id="UIReturnVarName" name="UIReturnVarName">
<input type="hidden" id="UIReturnValue" name="UIReturnValue" onkeyup="uiMain.forwardUICommand()">
<input type="hidden" id="UIScript" name="UIScript" onkeyup="eval(this.value)">
<div id="redrawMask" style="position:absolute;top:0px;left:0px;width:100%;height:100%;background:white;display:none;filter:Alpha(opacity=1,style=0)">
<script type="text/javascript">
uiMain.init();
<?php uiMainUpdateConnectedUsers(); ?>
</script>
</body>
<?php
/*
VB	=> uiMain.php
		UIReturnVarName + UIReturnValue => onkeyup=uiMain.forwardUICommand
	=> uiResources.php (main iframe) => wl.UIResultInject
		UIReturnVarName + UIReturnValue => onkeyup=forwardUICommand
		forwardUICommand: select frame
*/
