<?php
/**
 * RSS feed viewer
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.4.0
 */

require_once(INCLUDE_DIR.'mobileFunctions.php');

define('THUMBNAILS_SIZE',48);

/**
 * @desc Init mobile specific data
 *
 */
function mobileBookmarksInitResourceData(){
	if(cfRGetVar('mobileParametersLoaded')) return;

	cfRSetVar('mobileParametersLoaded',1);
}


/**
 * @desc Insert javascript
 */
function mobileBookmarksInsertScripts(){
	?>
<script type="text/javascript">
function go(l){window.open(l,"_blank")}
</script>
	<?php
}


// Init mobile specific data
mobileBookmarksInitResourceData();


/*
 ***************************************************************************************************************************
 * Insert HEAD, javascripts and comForm
 ***************************************************************************************************************************
 */
mfInsertHead();
outInsertStandardComForm($_SERVER['PHP_SELF']);
mobileBookmarksInsertScripts();



/*
 ***************************************************************************************************************************
 * Generate bookmarks tree (not treeView...) and thumbnails
 ***************************************************************************************************************************
 */
bfGenerateBookmarksTree();
$bookmarks=cfRGetVar('bookmarks');


$displayThumbnails=cfRGetVar('displayThumbnails');

// List table
echo mfListTable();

foreach (cfRGetVar('bookmarks') as $k=>$item){
	// Thumbnail
	if($item['type']=='b') {
		// Main link
		$link=$item['url'];

		// Title
		$title=cfUTF8Encode($item['name']);

		// Thumbnail
		if($displayThumbnails && bfThumbnailFile($item['url'])) {
			$src=cfExtImage(bfThumbnailFile($item['url']),THUMBNAILS_SIZE,floor(THUMBNAILS_SIZE/1.333));
			//$img='<img class="rssImg ani" src="'.$src.'" class="frLi16" style="width:'.THUMBNAILS_SIZE.'px;height:'.THUMBNAILS_SIZE.'px" alt="">';
			$img='<img src="'.$src.'" class="rssImg ani" style="width:1px;height:1px;opacity:1;margin:16px 24px 15px 23px" onload="s=this.style;s.width=s.height=s.margin=\'\';s.opacity=1">';
		}
		// Or favicon if thumbnail not yet generated or if no thumbnails
		else {
			$src=mfFaviconLink($item['url']);
			$img='<img src="'.$src.'" class="imgW16">';
		}

		// No thumbnail yet
		if(!$src) $src=outIcon('loading');

		/**
		 * Formated list item
		 */




		echo mfListItem('onclick="go(\''.$link.'\')"',$img,false,'<div class="lits">'.$title.'</div>'.$link,false,outImage(outIcon('go')),false);
			//echo mfListItem('onclick="go(\''.$link.'\')"','<img src="'.$src.'" class="frLi16" style="width:'.THUMBNAILS_SIZE.'px;height:'.THUMBNAILS_SIZE.'px" alt="">',false,'<div class="lits">'.$title.'</div>'.$link,false,outImage(outIcon('go')),false);
			//echo mfListItem('onclick="go(\''.$link.'\')"','<img src="'.$src.'" class="frLi16" style="width:'.THUMBNAILS_SIZE.'px;height:'.THUMBNAILS_SIZE.'px" alt="">',false,'<div class="lits">'.$title.'</div>'.$link,false,outImage(outIcon('go')),false);
	}
}
?>
</table></body></html>