<?php
/**
 * Photo album type 2 configuration file
 *
 * Configuration of type 2 photo album resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
require_once(INCLUDE_DIR.'outputFunctions.php');

/*
 ***************************************************************************************************************************
 * Verify access rights
 ***************************************************************************************************************************
 */
require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
$limitedConfig=rcConfigRights(true);


// Ffmpeg GPL version download request
if(!$limitedConfig && isset($_POST['loadFfmpeg']) && cfIsInApp()){
	// Ask UI to display ffmpeg load script
	cfServerSendCommand('executeScript script="/local/loadFfmpeg.php"');

	// Send async response
	cfAsyncHeader();
	cfAsyncFooter();
}


/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();

if($limitedConfig) echo '<div class="frame1Header">';

// Resource icon & name
rcInsertIconName($resourceData,true,array('rcSharedFilesBox'=>array(array('audio','video','image'),WEnv::host()->specialFolderHome(),array('noComputerRoot'=>1))));



/**
 * Shared folder or items
 */
//rcSharedFilesBox(array('audio','video','image'),WEnv::host()->specialFolderHome());

/*  Advanced config section
    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/
rcAdvancedConfigStart(array('noTopSeparator'=>1));

if(!$limitedConfig){
	// Upload
	rcProcessData('uploadAllowed',dataUserRights,'none',false,cfCaption('explorerCfgUpload').'&nbsp;&nbsp;&nbsp;'.outHelpButton('helpCfgUpload'),false);
	$resourceData['userRights_writeAllowed']=$resourceData['userRights_uploadAllowed'];

	// Download shortcuts
	rcProcessData('downloadShortcut',dataUserRights,'all',false,cfCaption('explorerDownloadShortcut').'&nbsp;&nbsp;&nbsp;'.outHelpButton('helpSDL'),false);

	// Multiple download
	rcProcessData('multipleDownloadAllowed',dataUserRights,'all',false,cfCaption('configAllowMultipleDownload').'&nbsp;&nbsp;&nbsp;'.outHelpButton('helpMD'),false);

	// Allow/Forbid remote creation of direct link
	rcProcessData('shareAllowed',dataUserRights,'none',false,cfCaption('shareAllowed').'&nbsp;&nbsp;&nbsp;'.outHelpButton('shareHelp','doShare'),false,false);

	// Allow/Forbid emailing files
	rcProcessData('mailoutAllowed',dataUserRights,'admin',false,cfCaption('sendByMail').'&nbsp;&nbsp;&nbsp;'.rcMailoutConfigButton(),false,false,array('faded'=>!Mailout::isMainConfigurationSet()));

	// Allow/Forbid file rating
	if(cfGGetVar('ratingAllowed')) rcProcessData('ratingAllowed',dataUserRights,'all',false,cfCaption('ratingAllowed'),false,false);

	// File access parameters (apply to files and folders located in "path")
	rcProcessData('downloadAllowed',dataBoolean,true,false,false/*do not display control*/); // Allow / Forbid read access to files and folders
	rcProcessData('modifyAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow / Forbid modifcation access to files and folders (need writeAllowed to true)
	rcProcessData('executeAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow / Forbid execute access to files
	rcProcessData('remoteDownloadAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow / Forbid remote download of files
	rcProcessData('sendAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow / Forbid send files
	rcProcessData('userTempDirAccessAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow / Forbid access to user temp directory (data/sessiondata/(session_id)/)
	rcProcessData('resourceDataDirAccessAllowed',dataBoolean,true,false,false/*do not display control*/); // Allow / Forbid access to resource directory (data/res/(res type)/(res subType)/(res file name)/)

}


/****************************************************************************************************************************
 * Image gallery specific parameters
 ****************************************************************************************************************************/
if(!$limitedConfig){
	// Display jpg/tiff EXIF data
	echo '<div class="configSubFrame">';
	echo '<div class="configSubFrameHeader">'.cfCaption('genImages').'</div>';

	rcProcessData('showExifData',dataBoolean,true,false,cfCaption('photoCfgExif'),false);
	// File view (image, audio,...)
	rcProcessData('fileViewAllowed',dataBoolean,true,false,false); // Allow user to see videos, audio, full-size images
	echo '</div>';
}
// Default slideshow interval, in seconds
rcProcessData('slideShowInterval',dataNumeric,4,array(1,1000),0);


/****************************************************************************************************************************
 * Video gallery specific parameters
 ****************************************************************************************************************************/

// Get ffmpeg version (GPL or LGPL)
$ffmpeg=cfFfmpegVersion();

if(!$limitedConfig){
		echo '<div class="configSubFrame">';
		echo '<div class="configSubFrameHeader">'.cfCaption('genVideos').' - '.cfCaption('explorerAudioPlayer').'</div>';

	/**
	 * Default video player
	 */
	rcProcessData('videoPlayer',dataList,'flashOrVideo',array('flashWii','flashOrVideo','divx','flash','wmp','qt','qtReenc','m3u','vlc'),false);
	rcProcessData('videoPlayerLocked',dataBoolean,false,false,false); // Set to true to forbid user to change video player


	/**
	 * original video
	 */
	rcProcessData('allowOriginalVideo',dataBoolean,true,false,outImage(outIcon('flash')).outImage(outIcon('qt')).outImage(outIcon('wmp')).outImage(outIcon('divx')).outImage(outIcon('vlc')).'&nbsp;'.cfCaption('videoCfgAllowOriginalVideo'));



	/**
	 * REENCODED VIDEOS
	 */
	echo '<div class="frame3">';
	rcProcessData('reencodedVideo',dataBoolean,true,false,outImageIcon('processing').cfCaption('videoCfgFlashStream').' - '.cfCaption('videoCfgUseFlash'),false);

	echo '<div style="padding-left:2em" id="reencodingParametersDiv" style="display:'.(($resourceData['reencodedVideo'])?'block':'none').'">';
	rcProcessData('flvAllowed',dataBoolean,true,false,'Flash',false);		// Flash (flv & f4v if GPL ffmpeg & flash player>10) video
	rcProcessData('webmAllowed',dataBoolean,true,false,'WebM',false);		// WebM video through HTML5 video player
	rcProcessData('ogvAllowed',dataBoolean,true,false,'Ogg Theora',false);	// Ogg Theora video through HTML5 video player
	rcProcessData('f4vForbidden',dataBoolean,false,false,false);			// Do not forbid F4V / h264 encoding

	//if(cfFfmpegVersion()=='LGPL') $resourceData['codecH264']
	echo '<input type="checkbox" disabled '.((cfFfmpegVersion()=='LGPL')?'':'checked="checked"').' style="vertical-align:middle"> H264';
	if(cfFfmpegVersion()=='LGPL') echo '<span class="warning" style="margin-left:0.1em">- '.cfCaption('ffmpegGPLWarning').'</span>';
	echo '<br><br>';


	// Flash  reencoded / real-time encode (not used anymore: only real-time reencoding since version 210Q)
	rcProcessData('flashStream',dataBoolean,true,false);

	echo outTableTransparent(false,'width:90%;margin:0.2em 0 1.2em 0').'<tr>';

	// Default reencoded output video size
	echo '<td style="font-weight:bold">'.cfCaption('genDefault').'</td><td>';
	rcProcessData('flashOutputSize',dataList,'400',array('original','1280','900','640','400','320','160'),array(
		array('',cfCaption('videoCfgFlashSize')),array(
		array('original',cfCaption('videoCfgSource')),
		array('1280','1280x720'),
		array('900','900x560'),
		array('640','640x400'),
		array('400','400x300'),
		array('320','320x240'),
		array('160','160x120')),
		false), false
	);

	echo '&nbsp; &nbsp;';
	// Default reencoded output video quality
	rcProcessData('flashOutputQuality',dataList,'high',array('original','high','medium','low'),array(
		array('',cfCaption('genQuality')),array(
		array('original',cfCaption('videoCfgSource')),
		array('high',cfCaption('genHigh')),
		array('medium',cfCaption('genMedium')),
		array('low',cfCaption('genLow'))),false), true
	);
	echo '</td></tr><tr>';

	// Max reencoded output video size
	echo '<td style="font-weight:bold">'.cfCaption('genMax').'</td><td>';
	rcProcessData('flashOutputSizeMax',dataList,'original',array('original','1280','900','640','400','320','160'),array(
		array('',cfCaption('videoCfgFlashSize')),array(
		array('original',cfCaption('videoCfgSource')),
		array('1280','1280x720'),
		array('900','900x560'),
		array('640','640x480'),
		array('400','400x300'),
		array('320','320x240'),
		array('160','160x120')),
		false), false
	);

	echo '&nbsp; &nbsp;';
	// Max reencoded output video quality
	rcProcessData('flashOutputQualityMax',dataList,'original',array('original','high','medium','low'),array(
		array('',cfCaption('genQuality')),array(
		array('original',cfCaption('videoCfgSource')),
		array('high',cfCaption('genHigh')),
		array('medium',cfCaption('genMedium')),
		array('low',cfCaption('genLow'))),false), true
	);
	echo '</td></tr></table>';

	echo '</div>';
	echo '</div>';

	/**
	 * GPL version not installed
	 */
	if($ffmpeg=='LGPL') {
		echo'</div>';
		echo '<br><div class="extendedWarning">';

		echo outImage(outIcon('ffmpeg'),false,false,'vertical-align:middle;margin-right:1em').' <span style="color:black">FFmpeg - '.cfCaption('genVersion').cfCaption('genSeparator').'</span>';

		// Ffmpeg OK/NOK caption
		if($ffmpeg=='GPL') echo '<b style="color:#090">GPL</b>'; else echo '<span class="warning">LGPL</span>';

		// Ffmpeg download link
		if($ffmpeg!='GPL' && cfIsInApp()) echo outBt(cfCaption('genDownload').' / '.cfCaption('genInstall'),outIcon('dl'),'javascript:void(sendData(\'loadFfmpeg=1\',\''.$_SERVER['REQUEST_URI'].'\'))',false,false,'style="float:right"');



		echo '<br>';
		echo '<table><tr><td style="width:40px">'.outImage(outIcon('iPhone'),false,false).'</td><td>';
		echo cfCaption('ffmpegGPLIPhoneWarning');
		echo '</td></tr></table></div>';
		echo '<div class="configSubFrame">';
	}
	rcProcessData('videoBufferTime',dataNumeric,4,false,false/*do not display control*/); // Default video buffer time (in seconds)




	rcProcessData('qtOutputSize',dataNumeric,480,false,false); /*do not display control*/ // qt encoding video width
	//rcProcessData('qtOutputQuality',dataText,'medium',false,false); /*do not display control*/ // qt encoding video quality

	echo '</div>';
}


/****************************************************************************************************************************
 * Audio specific parameters
 ****************************************************************************************************************************/

echo '<div class="configSubFrame">';
// Default audio player
echo '<div class="configSubFrameHeader">'.cfCaption('musicCfgDefaultPlayer').'</div>';

echo '<table id="table" class="frame3" style="margin-top:-5px"><tr><td style="padding-left:12px">';
rcProcessData('defaultAudioPlayer',dataList,'flash',array('qt','wmp','flash','external'),array(
array(false,'flash',array(outIcon('flash'),cfCaption('musicCfgFlash').'</td><td>')),
array(false,'qt',array(outIcon('qt'),'Quicktime'.'</td></tr><tr><td>')),
array(false,'wmp',array(outIcon('wmp'),cfCaption('musicCfgEmbeded').'</td><td>')),
array(false,'external',array(outIcon('m3u'),cfCaption('musicCfgExternal').'</td></tr>'))));
echo '</table>';

// Force non-inline player
rcProcessData('inlinePlayer',dataBoolean,false,false,false/*do not display control*/);

// Number of songs to put in global library random playlist
rcProcessData('plAddAllShuffleSize',dataNumeric,50,false,false/*do not display control*/);

echo '<br/>';

// Default output bit rate
// Maximum output bit rate
if(!$limitedConfig){
	rcProcessData('maxOutputBitRate',dataList,'original',array('original','128','64','32'),array(
	array(rcResourceImage('cfgMaxBitrate.png'),cfCaption('musicCfgMaxBr')),array(
	array('original',cfCaption('musicCfgNoLimit')),
	array('128',cfCaption('explorerAudio128')),
	array('64',cfCaption('explorerAudio64')),
	array('32',cfCaption('explorerAudio32'))),false), false);
	echo outHelpButton('helpAudioMaxBR');
}
echo '</div>';

rcProcessData('disableH264FlvEncoding',dataBoolean,false,false,false); /*do not display control*/ // force disable of h264 encoding for flash videos

/**
 * Thumbnails
 */
echo '<div class="configSubFrame">';
// Default audio player
echo '<div class="configSubFrameHeader" style="margin-bottom:0;padding-bottom:0">';
if(!$limitedConfig) echo outButton(cfCaption('genClear'),'javascript:clearThumbnails()',outIcon('eraser'),false,false,'style="position:absolute;top:2px;right:5px"');
echo cfCaption('genThumbnails').'</div>';

// Indicate that thumbnails must be generated
rcProcessData('photoThumbnailsNeeded',dataBoolean,true,false,false/*do not display control*/); // Generate images thumbnails when browsing a dir
rcProcessData('videoThumbnailsNeeded',dataBoolean,true,false,false/*do not display control*/); // Generate video thumbnails when browsing a dir

// nb of thumbnails per page
rcProcessData('itemsPerPage',dataList,'100',array('10','20','50','100','0'),array(
cfCaption('photoCfgNbThumbnailsPerPage'),array(
array('10','10'),
array('20','20'),
array('50','50'),
array('100','100'),
array('0',cfCaption('genAll'))),false), false);

// Thumbnails size
rcProcessData('thumbnailsSize',dataNumeric,240,false,false/*do not display control*/); // Biggest thumbnails size */
rcProcessData('thumbnailsSizeFactorLocked',dataBoolean,false,false,false/*do not display control*/); // True to prevent user from modifying thumbnail size factor


echo '<br><br>'.outTableTransparent(false,'width:90%').'<tr><td style="width:250px;position:relative;zoom:1">';

// Thumbnails size controls
$thumbnailsSizeFactor=array(
	'0'=>outIcon('efTNSize480'),
	'1'=>outIcon('efTNSize481'),
	'2'=>outIcon('efTNSize482')
);

echo '<div style="display:none">';
$controlDefinition=array(); foreach ($thumbnailsSizeFactor as $k=>$v) $controlDefinition[$k]=array(' ',$k,' '.$v);
rcProcessData('thumbnailsSizeFactor',dataList,'1',array(0,1,2),$controlDefinition);
echo '</div>';

echo '<span>'.cfCaption('genSize').'</span><br>';
foreach ($thumbnailsSizeFactor as $key=>$icon){
	echo outBlockItem('thumbnailsSizeFactorSwitch','<img src="'.$icon.'" alt="">','id="thumbnailsSizeFactorSwitch'.$key.'"','margin-right:7px;margin-left:0px;padding:5px;',array('onclick'=>'thumbnailsSizeFactorSet(\''.$key.'\')'),(($key==$resourceData['thumbnailsSizeFactor'])?'sel':'unsel'));
}
echo '</td><td style="position:relative;zoom:1">';


// Frames border style
$thumbnailBorderFrameOpts=array(
	'list'=>outIcon('videoBorders480'),
	'icons'=>outIcon('videoBorders481'),
	'resource'=>outIcon('videoBorders482')
);
echo '<div style="display:none">';
$controlDefinition=array(); foreach ($thumbnailBorderFrameOpts as $k=>$v) $controlDefinition[$k]=array(' ',$k,' '.$v);
@rcProcessData('filesLayout',dataList,'resource',array('list','icons','resource'),$controlDefinition);
echo '</div>';

echo '<span>'.cfCaption('defaultLayout').'</span><br>';
foreach ($thumbnailBorderFrameOpts as $key=>$icon){
	echo outBlockItem('filesLayoutSwitch','<img src="'.$icon.'" alt="">','id="filesLayoutSwitch'.$key.'"','margin-right:7px;margin-left:0px;padding:5px;',array('onclick'=>'filesLayoutSet(\''.$key.'\')'),(($key===$resourceData['filesLayout'])?'sel':'unsel'));
}
echo '</td></tr></table>';



// Layout
rcProcessData('filesLayout',dataText,'resource',false,false/*do not display control*/); // Default files layout: resource specific */
rcProcessData('filesLayoutLocked',dataBoolean,false,false,false/*do not display control*/); // Do not lock files layout (allow user to change) */

// Border width of white frame around thumbnails.
rcProcessData('thumbnailBorderWidth',dataNumeric,12,array(0,100),false); // Max thumbnail width

// Monitor thumbnails generation
rcProcessData('monitorThumbnailGen',dataBoolean,true,false,false/*do not display control*/);

// Frames border style
rcProcessData('thumbnailBorderFrame',dataBoolean,true,false,false);


// Preview
// No preview for this resource
if(!$limitedConfig){
	rcProcessData('previewDisplay',dataBoolean,false,false,false/*do not display control*/); // Display a preview image
	rcProcessData('stretchSmallImages',dataBoolean,false,false,false); // Strech small images when displayed (preview and full view)
}
echo '</div>';


// Users comments
if(!$limitedConfig) rcProcessData('commentsAllowed',dataBoolean,false,false,false); // Allow / Forbid users to comment files (images, audio files...)

// End of advanced config panel
rcAdvancedConfigEnd();

// Comments panel
echo rcCommentsPanelControl();

// Photo album theme
echo rcThemeSelectionControl();

// Save / cancel buttons
echo '<br/>'.rcButtonSaveCancel();

// If resource need access to resource data dir, create it
rcCreateResourceDataDir();

// Indicate that resource has been initialized
if(!$limitedConfig) rcProcessData('resourceConfigured',dataBoolean,true,false,false/*do not display control*/);

// Save parameters
rcWriteResourceFile($resourceData, $fileName);
?>
<script type="text/javascript">
// Clear thumbnails
function clearThumbnails(browser){wl.mask.show(0,0); sendData("clearThumbnails=1",undefined,true,3);}

// Change thumbnails Size Factor
function thumbnailsSizeFactorSet(l){
	var i,items=D.getElementsByName("thumbnailsSizeFactor"),id='thumbnailsSizeFactor'+l;
	for(i=0;i<(items.length);i++){
		if(items[i].value==l) D.getElementsByName("thumbnailsSizeFactor")[i].checked="checked"
	}
	eSaveBt('thumbnailsSizeFactor',l);
}

// Change display layout
function filesLayoutSet(l){
	var i,items=D.getElementsByName("filesLayout"),id='filesLayout'+l;
	for(i=0;i<(items.length);i++){
		if(items[i].value==l) D.getElementsByName("filesLayout")[i].checked="checked"
	}
	eSaveBt('filesLayout',l);
}

</script>