<?php
/**
 * NATURE THEME LOGIN FORM
 *
 * Included by login.php
 * Display login form
 *
 * Use 2 variables :
 *
 * string $userToDisplaySeqNumber : id of pre-selected user
 * boolean $wrongPasswordSent : true if an incorrect password has been sent
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

// number of forms to be displayed
$nbForms=count($_ENV['users']);
// sequential number of pre-selected form
if(isset($userToDisplay)){
	$i=0;
	foreach ($_ENV['users'] as $key=>$value) {if($key===$userToDisplay) $userToDisplaySeqNumber=$i;	$i++;}
}
elseif (isset($_ENV['users'][0])){
	$userToDisplay=0;
	$userToDisplaySeqNumber=0;
}
else {
	if($nbForms==1){foreach ($_ENV['users'] as $key=>$value) {$userToDisplay=$key; $userToDisplaySeqNumber=0;}} else $userToDisplaySeqNumber=-1;
}



/*
 ***************************************************************************************************************************
 * Async Response
 ***************************************************************************************************************************
 */
if(cfIsAsync() && isset($_POST['user'])){
	echo cfAsyncHeader();

	// If security issue detected, display error message
	if($securityEvent)echo cfAsyncXMLJSaction('dgi("securityEvent").innerHTML="'.str_replace('"',"''",cfUTF8Encode($securityEvent)).'";');
	echo cfAsyncXMLJSaction('if(W.resetInputs) resetInputs();');
	if($wrongPasswordSent || $wrongUserSent){
		$errorText=str_replace('"',"''",(($wrongUserSent)?cfCaption('loginBadPasswordOrAccount'):cfCaption('loginBadPassword')));
		echo cfAsyncXMLJSaction('dgi("wrongPassword").innerHTML="'.$errorText.'";');
	}
	echo cfAsyncXMLJSaction('if(dgi("password'.$userToDisplaySeqNumber.'")) dgi("password'.$userToDisplaySeqNumber.'").focus();');
	echo cfAsyncXMLJSaction('wl.mask.hide()');
	cfAsyncFooter();
}


// Insert HTML Head and Javascript
cfInsertHEAD(false);
cfScriptLink('wz_dragdrop.js');

?>
<script language="JavaScript" type="text/javascript">
<!--
var currentUser=-1;
function submitUser(nb){
	document.loginForm.elements['userId'].value=dgi("userId"+nb).innerHTML;
	if(dgi("userName"+nb)) document.loginForm.elements['user'].value=dgi("userName"+nb).value; else document.loginForm.elements['user'].value='';
	if(dgi("password"+nb)) document.loginForm.elements['password'].value=dgi("password"+nb).value; else document.loginForm.elements['password'].value='';
	dgi("wrongPassword").innerHTML="&nbsp;";
	startEncryption();
}

function resetInputs(){
	if(dgi("encryptionLockSend")) dgi("encryptionLockSend").style.display="none";
	for(var i = 0; i < <?php echo $nbForms;?>; i++){
		if(dgi("password"+i)) dgi("password"+i).value = "";
	}
}

function checkKey(e){
	if(currentUser==-1) return;
	var kc;
	if(e) kc=e.which; else {if(window.event) kc=window.event.keyCode; else return;}
	if(kc==13 && !wl.mask.shown) {
		if(dgi("userName"+currentUser) && dgi("password"+currentUser).value=='') dgi("password"+currentUser).focus(); else submitUser(currentUser);
	}
}
function preEncodingMessage(){
	dgi('wrongPassword').innerHTML="<?php echo cfCaption('passwordCrypt'); ?>";
}
function postEncodingMessage(){
	dgi('wrongPassword').innerHTML="<?php echo cfCaption('loginConnectButton'); ?>";
}
document.onkeypress=checkKey;
//-->
</script>
<?php
//<BODY>
if($userToDisplaySeqNumber==-1 || $_ENV['users'][$userToDisplay]['authenticationMethod']=='noAuthentication') echo '<body class="mainFrameBody">';
elseif($userToDisplay==0) echo '<body onload="dgi(\'userName0\').focus()" class="mainFrameBody">';
else echo '<body class="mainFrameBody">';
?>
<div class="win" style="top:200px; left:200px; width:500px; height:300px; position:absolute;"><table class="winActive"><tr> <td class="winTH"><table><tr> <td class="winTL"></td> <td class="winT"><table><tr> <td class="winTT"></td></tr></table></td> <td class="winTR"></td></tr></table></td></tr><tr> <td><table><tr> <td class="winL"></td> <td class="winC"></td> <td class="winR"></td></tr><tr> <td class="winBL"></td> <td class="winB"></td> <td class="winBR"></td></tr></table></td></tr></table><div class="winClose"></div><div class="winMax"></div><div class="winMin"></div><div class="winReload"></div><div class="winReloading"></div><div class="winIcon"></div><div class="winCapt"></div></div>

<?php
// Insert Login form and RSA encryption scripts and HTML
includeLoginFormAndScripts();

// Login message
if(cfGGetVar('loginMessage')) echo '<div class="loginMessage">'.cfUTF8Encode(cfGGetVar('loginMessage'),false,false).'</div>';

// Table used for vertical & middle alignment
echo outTableTransparent(false,'height:97%; width:100%');
echo '<tr><td height="100%" valign="middle" align="center">';

// Login Frame
echo '<DIV class="frame1" style="width:320px">';
echo '<DIV class="frame1Header" style="margin-bottom:2px">'.cfCaption('loginSelectAccount')."</DIV>\n";
echo "<br />\n";

/*
 * Users list
 */
	$i=0;
	echo '<table style="width:100%; vertical-align:top; padding-left:0px; padding-right:0px;margin:0px;" cellspacing=0 cellpadding=0><colgroup><col width="0"><col width="90"><col width="90"></colgroup>';

	foreach($_ENV['users'] as $key=>$value){
		if($value['name']) $name=cfUTF8Encode($value['name']);
		else $name=cfCaption('genGroup');

		echo '<tr class="userFrame"><td class="name">';

		// Hidden user id
		echo '<span id="userId'.(0+$i).'" style="display:none">'.$key.'</span>';

		// User Name
		if($value['name']) echo'<span style="margin-left:1em">'.cfStrTruncate($name,30).'</span>';

		if(!$value['name']) echo '<input type="text" size="20" id="userName0" style="margin-left:1em" onfocus="currentUser='.(0+$i).'">';

		// Hint
		if(isset($value['hint']) && strlen($value['hint'])>0) echo outButton('?','javascript:alert(\''.cfCaptionJS('logHint').cfCaption('genSeparator').cfUTF8Encode($value['hint']).'\')', false,false,false);

		echo "</td><td class=\"password\">\n";
		// Password
		if($value['authenticationMethod']!='noAuthentication') echo '<input type="password" size="20" id="password'.$i.'" onfocus="currentUser='.(0+$i).'">';
		else echo '&nbsp;';
		echo '</td><td class="submit">';
		// Submit
		echo outButton(cfCaption('loginConnectButton'),'javascript:submitUser('.$i.')',outIcon('go'));
		echo "</td></tr>\n";
		echo "<tr class=\"inter\"><td>&nbsp;</td></tr>\n";
		$i++;
	}
	echo '</table>';

// Theme change control
if(cfGGetVar('allowUserThemeChange')) {
	echo '<div style="width:100%; height:3px; border-top:1px dashed #119">&nbsp;</div>';
	echo outThemeSelectionControl('general',false,'POST',false,false,false);
}

// Wrong password label
echo '<span id="wrongPassword" class="warning" style="margin-left:3em">'.(($wrongPasswordSent)?cfCaption('loginBadPassword'):'&nbsp;').'</span>';

echo '</div>';
echo '</table>';

echo '<span onclick="window.open(\''.APP_SITE.'\')" style="cursor:pointer; position:absolute;top:7px; right:7px">Weezo - '.cfGGetVar('appVersion').'&nbsp;'.outImage(outIcon('logoSmall'),'#',false,'vertical-align:top; margin-left:1em').'</span>';

// Error message div
echo '<div style="position:absolute;top:10px;right:10px;color:red; text-align:right" id="securityEvent">'.(($securityEvent)?cfUTF8Encode($securityEvent):'').'</div>';

echo "</body></html>";
?>